#!/usr/bin/perl
#######################################################
# Locked Area Lite Version 3.2 Linux Stable
#                  http://www.lockedarea.com/
# Originally Released:     1st September 1999 (v1.0)
# Latest Release:          29th September 2003 (v3.2)
#######################################################
#
# COPYRIGHT NOTE:
# Locked Area Lite may be used and modified by anyone so
# long as they have a fully registered copy and this 
# copyright notice and the comments above remain intact.
# By using this code you agree to indemnify Neil Skirrow 
# and LockedArea.com from any liability that might arise
# from its use. Selling the code for this program without 
# prior written consent is expressly forbidden. In other
# words, please ask first before you try and make money
# off of our program. Obtain permission before 
# redistributing this software over the Internet or in 
# any other medium. In all cases copyright and header 
# must remain intact.  We cannot be held responsible 
# for any harm this may cause. 
#
#######################################################
use CGI qw(:standard); 	# Calls CGI.pm Library
$query = new CGI;
use Fcntl qw(:flock);  	# Calls File Locking Library
use CGI::Carp qw(fatalsToBrowser);
# Remove above hash if setup.cgi returns a 500 error.
#######################################################
# The above three lines are essential to the script, if
# they are causing you an error, you don't have the
# required modules to use Locked Area Lite v3.2 Linux.
# Contact your web host and ask them to install them as
# they are essential modules.
#######################################################
# THIS FILE REQUIRES NO MANUAL MODIFICATION TO BE USED
# WITH THE EXCEPTION OF THE PATH TO PERL ON THE TOP 
# LINE.
#######################################################
# This installation file is intended to be used on 
# systems running Unix or Linux.  Support is only
# available to users installing on Linux, Unix, Sun and
# Cobalt servers.  We cannot gurantee that this will
# work on Windows machines though it has been known to.
#######################################################
# All installations of Locked Area Lite MUST maintain
# a the text and link back to LockedArea.com.  Please
# use the following text: "Powered by Locked Area Lite 
# v3.2 Linux Stable, a product of LockedArea.com."
# The LockedArea.com must be linked to
# http://www.lockedarea.com.  Failure to maintain the
# link back may result in legal action.
#######################################################
$version = 'v3.2';
$versionrel = '09/29/03';
$versiontype = 'Linux Stable Build #47';
print "Content-type: text/html\n\n";
&welcome if ($ENV{'REQUEST_METHOD'} eq "GET");
$install = $query->param('install');
&install if ($install && $ENV{'REQUEST_METHOD'} eq "POST");
sub welcome {
$cgidir = $ENV{'SCRIPT_FILENAME'};
$cgidir =~s/(.*)\/.*//ig;
$cgidir=$1;
$membersdb = "$cgidir/members.db";
$memdir = "$ENV{'DOCUMENT_ROOT'}/members";
$htpasswd = "$memdir/.htpasswd";
print qq~
<html><head><title>Locked Area Lite Installation Wizard</title></head>
<body bgcolor="#F1F1F1" text="Navy" link="#000000" vlink="#111111">
<table width=500 cellpadding=2 cellspacing=0 border=0>
<tr><td bgcolor="#dddddd"><b><font face=Arial size=2>Locked Area Lite Installation Wizard - Installation</font></b></td></tr>
<tr><td><font face=Arial size=2>
<br>
</font>
<ul>
<font face="Arial" size="2">
Please complete ALL of the below fields.</font><font face=Arial size=2>
<p>
</ul>
<form action="setup.cgi" method="post">
<input type="hidden" name="install" value="yes">
</font>
<center><table width=400 cellpadding=2 cellspacing=0 border=0>
<tr><td><b><font face="Arial" size="2">CGI Script Directory Path</font></b></td></tr>
<tr><td><font face="Arial" size="2">What's the FULL path to the directory where you want to create the Locked Area CGI scripts and admin directory?  Do not end with a trailing slash and do NOT enter a relative path or URL.  It must be a full path and the directory must already exist and be writable (e.g. 777 or 755).<br>
    e.g. /home/username/dir/cgi-bin</font></td></tr>
<tr><td><font face=Arial size=2>
<input type="text" size="45" name="cgiscriptdir" value="$cgidir"><br>&nbsp;
</font></td></tr>
<tr>
  <td><b><font face="Arial" size="2">Member's Area Directory Path</font></b></td>
</tr>
<tr>
  <td><font face="Arial" size="2">What's the FULL path to the directory where you want to create your members area?  Do not end with a trailing slash and do NOT enter a relative path or URL.  It must be a full path and the directory must already exist and be writable (e.g. 777 or 755).<br>
    e.g. /home/username/dir/members</font></td>
</tr>
<tr>
  <td><font face=Arial size=2>
<input type="text" size="45" name="membersdir" value="$memdir"><br>&nbsp;
</font></td>
</tr>
<tr>
  <td><b><font face=Arial size=2>
Member's Database Location
</font></b></td>
</tr>
<tr>
  <td><font face="Arial" size="2">What's the FULL path to the directory where
    you want to create your member's database.&nbsp; Please use a full/absolute
    path that ends with a filename and extension<br>
    e.g. /home/username/dir/dir/members.db</font></td>
</tr>
<tr>
  <td><font face=Arial size=2>
<input type="text" size="45" name="membersdb" value="$membersdb"><br>&nbsp;
</font></td>
</tr>
<tr>
  <td><b><font face=Arial size=2>
HTPasswd File Location
</font></b></td>
</tr>
<tr>
  <td><font face=Arial size=2>
Where do you want to create your .htpasswd file which will contain the login
details for the member's area?&nbsp; It doesn't necessarily have to be in the
member's area but if you receive a double pop-up after installation, set it to
be in the member's area.&nbsp; Please use a full/absolute path that ends with a
filename and extension<br>
e.g. /home/username/dir/dir/.htpasswd
</font></td>
</tr>
<tr>
  <td><font face=Arial size=2>
<input type="text" size="45" name="htpasswd" value="$htpasswd"><br>&nbsp;
</font></td>
</tr>
<tr>
  <td><b><font face="Arial" size="2">Members Area Directory URL</font></b></td>
</tr>
<tr>
  <td><font face="Arial" size="2">What's the url of your member's area.&nbsp; Do
    not include the http://<br>
    e.g. www.yourdomain.com/members/</font></td>
</tr>
<tr>
  <td><font face=Arial size=2>
<input type="text" size="45" name="membersurl" value="$membersurl"><br>&nbsp;
</font></td>
</tr>
<tr><td><b><font face="Arial" size="2">CGI Script Directory URL</font></b></td></tr>
<tr><td><font face="Arial" size="2">What's the url of the directory where your
    cgi scripts will be created.&nbsp; The url equivalent of CGI Script
    Directory Path above.&nbsp; Do not include a trailing slash.<br>
    e.g. http://www.yourdomain.com/cgi-bin/la</font></td></tr>
<tr><td><font face=Arial size=2>
<input type="text" size="45" name="cgiurl" value="$cgiurl"><br>&nbsp;
</font></td></tr>
<tr>
  <td><b><font size="2"><font face=Arial>
Image Directory
</font><font face=Arial>
 URL
</font></font></b></td>
</tr>
<tr>
  <td><font face=Arial size=2>
What's the url of the directory with the Locked Area images in.&nbsp; Please do
not end the url with a trailing slash.<br>
e.g. http://www.yourdomain.com/images
</font></td>
</tr>
<tr>
  <td><font face=Arial size=2>
<input type="text" size="45" name="imageurl" value="$imageurl"><br>&nbsp;
</font></td>
</tr>
<tr>
  <td><b><font face=Arial size=2>
Path to Sendmail
</font></b></td>
</tr>
<tr>
  <td><font face=Arial size=2>
What's the path to sendmail on your server.<br>
e.g. /usr/sbin/sendmail or /usr/lib/sendmail
</font></td>
</tr>
<tr>
  <td><font face=Arial size=2>
<input type="text" size="35" name="sendmail" value="/usr/sbin/sendmail"><br>&nbsp;
</font></td>
</tr>
<tr>
  <td><b><font face=Arial size=2>
Path to Perl
</font></b></td>
</tr>
<tr>
  <td><font face=Arial size=2>
What's the path to perl on your server.<br>
e.g. #!/usr/bin/perl or #!/usr/local/bin/perl
</font></td>
</tr>
<tr>
  <td><font face=Arial size=2>
<input type="text" size="35" name="pathtoperl" value="#!/usr/bin/perl"><br>&nbsp;
</font></td>
</tr>
<tr>
  <td><b><font face=Arial size=2>
CGI Script Permissions
</font></b></td>
</tr>
<tr>
  <td><font face=Arial size=2>
What permission should be set on the .cgi scripts to make them executable on your server?  755 is the standard on Unix.
</font></td>
</tr>
<tr>
  <td><font face=Arial size=2>
<input type="text" size="35" name="permission" value="755"><br>&nbsp;
</font></td>
</tr>
<tr>
  <td><b><font face="Arial" size="2">Members Area </font></b><font size="2"><b><font face=Arial>
Name
</font></b></font></td>
</tr>
<tr>
  <td><font face="Arial" size="2">What's do you want to call your member's area?<br>
    e.g. YourDomain.com Member's Area</font></td>
</tr>
<tr>
  <td><font face=Arial size=2>
<input type="text" size="35" name="membersname"><br>&nbsp;
</font></td>
</tr>
<tr>
  <td><b><font face=Arial size=2>
Administrator Name
</font></b></td>
</tr>
<tr>
  <td><font face=Arial size=2>
What's the name of the administrator for this installation of Locked Area.<br>
e.g. Joe Bloggs
</font></td>
</tr>
<tr>
  <td><font face=Arial size=2>
<input type="text" size="35" name="adminname" value="$adminname"><br>&nbsp;
</font></td>
</tr>
<tr>
  <td><b><font face=Arial size=2>
Administrator Email Address
</font></b></td>
</tr>
<tr>
  <td><font face=Arial size=2>
What's the administrators email address?&nbsp; All the emails sent by the script
will come from this email address.<br>
e.g. you\@yourdomain.com
</font></td>
</tr>
<tr>
  <td><font face=Arial size=2>
<input type="text" size="35" name="adminemail" value="$adminmail"><br>&nbsp;</font></td>
</tr>
<tr>
  <td><b><font face=Arial size=2>
Administrator Password
</font></b></td>
</tr>
<tr>
  <td><font face="Arial" size="2">What's password do you wish to use for the
    administration panel?&nbsp; Choose carefully!</font></td>
</tr>
<tr>
  <td><font face=Arial size=2>
<input type="text" size="35" name="adminpassword"><br>&nbsp;
</font></td>
</tr>
<tr>
  <td><b><font face=Arial size=2>
Cobalt RAQ</font></b></td>
</tr>
<tr>
  <td><font face="Arial" size="2">Are you on a Cobalt RAQ server?  Tick if you are.<br><small>
  If you're not sure, either check with your host or install with the tickbox unticked.  If when trying to access the member's area you get a Internal Server Error, re-install with the tick box ticked.</small></font></td>
</tr>
<tr>
  <td><font face=Arial size=2>
<input type="checkbox" name="cobaltraq" value="yes"><br>&nbsp;
</font></td>
</tr>
<tr><td><p><font face="Arial" size="2">Please double check the above variables and click
    'Install'.&nbsp; This will setup the password protection for the member's
    area, create the necessary database files and create the cgi scripts.&nbsp;
    Make sure that </font><font face="Arial" size="2">Member's Area Directory
    Path and CGI Script Directory Path are correct and that those directories
    are either set to 777 or 755.</font></td></tr>
<tr><td align=center><font face=Arial size=2>
<input type="submit" value="Install">
</font></td></tr>
</table></center>
</form>
    <font face=Arial size=1>
    Please note, when you click install the following information about your installation of Locked Area Lite is sent to the LockedArea.com 
    web site for logging.  The following details are collected: The version of LA Lite you are installing, the location of your Locked Area 
    Lite cgi scripts, the url of your member's area, the administrators name and email address and whether or not you are on a Cobalt RAQ
    server or not.  This information will not be given to any other persons or organisations and will only be used by permitted LockedArea.com staff.


<p>
</font>
<p><font face=Arial size=2>
&nbsp;
</font></td></tr>
<tr><td bgcolor="#dddddd"><font face="Arial" size="1">&copy; Copyright 1999 -
    2003 Neil Skirrow and <a href="http://www.locked-area.com">LockedArea.com</a>.  All Rights Reserved.</font></td></tr>
</table>
</body></html>
~;

exit;
}


sub install {
$cgiscriptdir = $query->param('cgiscriptdir');
$membersdir = $query->param('membersdir');
$membersdb = $query->param('membersdb');
$htpasswd = $query->param('htpasswd');
$membersurl = $query->param('membersurl');
$cgiurl = $query->param('cgiurl');
$imageurl = $query->param('imageurl');
$sendmail = $query->param('sendmail');
$pathtoperl = $query->param('pathtoperl');
$membersname = $query->param('membersname');
$adminname = $query->param('adminname');
$adminemail = $query->param('adminemail');
$adminpassword = $query->param('adminpassword');
$cobaltraq = $query->param('cobaltraq');
$permission = $query->param('permission');

if ($cgiscriptdir eq "") { &error;
} elsif ($membersdir eq "") { &error;
} elsif ($membersdb eq "") { &error;
} elsif ($htpasswd eq "") { &error;
} elsif ($membersurl eq "") { &error;
} elsif ($cgiurl eq "") { &error;
} elsif ($imageurl eq "") { &error;
} elsif ($sendmail eq "") { &error;
} elsif ($membersname eq "") { &error;
} elsif ($adminname eq "") { &error;
} elsif ($adminemail eq "") { &error;
} elsif ($adminpassword eq "") { &error;
} elsif ($pathtoperl eq "") { &error;
} else {
&create_scripts;
&create_config;
&create_members;

print qq~
<html><head><title>Locked Area Pro Installation Wizard</title></head>
<body bgcolor="#F1F1F1" text="Navy" link="#000000" vlink="#111111">
~;
print "<img src=\"http://www.lockedarea.com/cgi-bin/userv3.cgi?1=3.2&2=$cgiurl&3=$membersurl&4=$adminname&5=$adminemail&6=$cobaltraq\" height=\"1\" width=\"1\" border=\"0\">\n";
print qq~
<table width=500 cellpadding=2 cellspacing=0 border=0>
<tr><td bgcolor="#dddddd"><b><font face=Arial size=2>Locked Area Lite Installation Wizard -
    Installation Success</font></b></td></tr>
<tr><td><font face=Arial size=2>
<br>
</font>
<ul>
<font face="Arial" size="2"><b>Locked Area Lite $version ($versionrel $versiontype) installed.<p>
</b>Now, providing you did follow all the instructions correctly, the below should work!
<p><b>Your members area:</b><br>
        <a href="http://$membersurl">http://$membersurl</a><br>
        You have no members yet so it won't work but check the login
        window pops up.<br>
        <strong>Your administration panel:</strong><br>
        <a href="$cgiurl/admin.cgi">$cgiurl/admin.cgi</a> <br>
        <strong>Your user registration form:</strong><br>
        <a href="$cgiurl/locked.cgi">$cgiurl/locked.cgi</a> </p>
<br>
~;
if ($members_create_index eq 0) {
print "<b>Notice:</b><br>Locked Area was not able to create an index.html file in your member's area because one already exists, this is not a problem you need to worry about!<p>";
} else {
print "<b>Notice:</b><br>Locked Area has created an index.html file in your member's area to give you explanations of a few of Locked Area Lite's features.<p>";
}
print qq~
        <a href="http://cgi.resourceindex.com/detail/04463.html">Want to write a comment about Locked Area Lite?&nbsp;
        Click Here.</a></font></p>

</ul>
<center>
	<table width=400 cellpadding=0 cellspacing=0 border=0><tr><td align=center width=200>
	
	<table border="0" cellpadding="0"
	            cellspacing="0" width=95%>
	              <tr><td align=center><font face="Arial" size="2"><b>HotScripts.com</b></font></tr></tr>
	              <tr>
	                <td><form action="http://www.hotscripts.com/cgi-bin/rate.cgi" method="POST">
	                  <input type="hidden" name="ID" value="4006"><b><div align="center"><center><p><font face="Arial"
	                  size="2">Script Rating: </b>
	                  <select name="ex_rate" size="1">
	<option value="5" selected>Excellent!</option>
	<option value="4">Very Good</option>
	<option value="3">Good</option>
	<option value="2">Fair</option>
	<option value="1">Poor</option>
	</select><input type="submit" value="Rate It!"><br>&nbsp; </font></p>
	                  </center></div>
	                </form>
	                </td>
	              </tr>
	            </table>
	
	
	</td><td align=center width=200>
	
	<table border="0" cellpadding="0"
	            cellspacing="0" width=95%>
	              <tr><td align=center><font face="Arial" size="2"><b>The CGI Resource Index</b></font></tr></tr>
	              <tr>
	                <td><form method="POST" action="http://cgi-resources.com/rate/index.cgi">
	                  <input type="hidden" name="referer" value="http://cgi-resources.com/"><input type="hidden"
	                  name="link_code" value="04463"><input type="hidden" name="category_name"
	                  value="Programs and Scripts/Perl/Password Protection/"><input type="hidden"
	                  name="link_name" value="Locked Area"><b><div align="center"><center><p><font face="Arial"
	                  size="2">Script Rating: </b><select name="rating" size="1">
	                    <option selected>-- </option>
	                    <option>10 </option>
	                    <option>9 </option>
	                    <option>8 </option>
	                    <option>7 </option>
	                    <option>6 </option>
	                    <option>5 </option>
	                    <option>4 </option>
	                    <option>3 </option>
	                    <option>2 </option>
	                    <option>1 </option>
	                  </select> <input type="submit" value="Rate It!"></font><br>
	                  <font face="Arial" size="2">10 - Great / 0 - Poor</font></p>
	                  </center></div>
	                </form>
	                </td>
	              </tr>
	            </table>
	
</td></tr></table> </center>
    <font face=Arial size=2>
<p>
</font>
<p><font face=Arial size=2>
&nbsp;
</font></td></tr>
<tr><td bgcolor="#dddddd"><font face="Arial" size="1">&copy; Copyright 1999 -
    2003 Neil Skirrow and <a href="http://www.locked-area.com">LockedArea.com</a>.  All Rights Reserved.</font></td></tr>
</table>
</body></html>
~;
exit;
}
}

sub error {

print qq~
<html><head><title>Locked Area Pro Installation Wizard</title></head>
<body bgcolor="#F1F1F1" text="Navy" link="#000000" vlink="#111111">
<table width=500 cellpadding=2 cellspacing=0 border=0>
<tr><td bgcolor="#dddddd"><b><font face=Arial size=2>Locked Area Lite Installation Wizard -
    Configuration Error</font></b></td></tr>
<tr><td><font face=Arial size=2>
<br>
</font>
<ul>
<font face="Arial" size="2">You did not complete all the fields.&nbsp; Please
click back and try again.</font>
</ul>
    <font face=Arial size=2>
<p>
</font>
<p><font face=Arial size=2>
&nbsp;
</font></td></tr>
<tr><td bgcolor="#dddddd"><font face="Arial" size="1">&copy; Copyright 1999 -
    2003 Neil Skirrow and <a href="http://www.locked-area.com">LockedArea.com</a>.  All Rights Reserved.</font></td></tr>
</table>
</body></html>
~;
exit;
}

sub create_scripts {
$pathperl = $pathtoperl;
open(ADMIN, ">$cgiscriptdir/admin.cgi") || &die_clean("Locked Area Error: Cannot open/create admin.cgi file: $!\n");
flock (ADMIN, LOCK_EX) || &die_clean("Locked Area Error: Cannot flock admin.cgi file.  $!\n");
print ADMIN "$pathperl\n";
print ADMIN '#######################################################
# Locked Area Lite Version 3.2 Linux Stable
#                  http://www.lockedarea.com/
# Originally Released:     1st September 1999 (v1.0)
# Latest Release:          8th June 2003 (v3.2)
#######################################################
#
# COPYRIGHT NOTE:
# Locked Area Lite may be used and modified by anyone so
# long as they have a fully registered copy and this 
# copyright notice and the comments above remain intact.
# By using this code you agree to indemnify Neil Skirrow 
# and LockedArea.com from any liability that might arise
# from its use. Selling the code for this program without 
# prior written consent is expressly forbidden. In other
# words, please ask first before you try and make money
# off of our program. Obtain permission before 
# redistributing this software over the Internet or in 
# any other medium. In all cases copyright and header 
# must remain intact.  We cannot be held responsible 
# for any harm this may cause. 
#
#######################################################
use CGI qw(:standard); 	# Calls CGI.pm Library
$query = new CGI;
use Fcntl qw(:flock);  	# Calls File Locking Library
#######################################################
# The above three lines are essential to the script, if
# they are causing you an error, you don\'t have the
# required modules to use Locked Area Lite v3.2 Linux.
# Contact your web host and ask them to install them as
# they are essential modules.
#######################################################
# THIS FILE REQUIRES NO MANUAL MODIFICATION TO BE USED
# WITH THE EXCEPTION OF THE PATH TO PERL ON THE TOP 
# LINE OTHERWISE ALL CONFIGURATION IS DONE FROM THE 
# ADMIN PANEL.
#######################################################
require "variables.pl";	# Go and get the variables.
print "Content-type: text/html\n\n";

$admin_main = $query->param(\'admin_main\');
&admin_main if ($admin_main && $ENV{\'REQUEST_METHOD\'} eq "POST");
$remove_user = $query->param(\'remove_user\');
&remove_user if ($remove_user && $ENV{\'REQUEST_METHOD\'} eq "POST");
$add_user = $query->param(\'add_user\');
&add_user if ($add_user && $ENV{\'REQUEST_METHOD\'} eq "POST");
$update_config = $query->param(\'update_config\');
&update_config if ($update_config && $ENV{\'REQUEST_METHOD\'} eq "POST");
$send_email = $query->param(\'send_email\');
if ($send_email && $ENV{\'REQUEST_METHOD\'} eq "POST") {
	$subject = $query->param(\'subject\');
	$content = $query->param(\'content\');
	$footer = $query->param(\'footer\');
	&send_email($adminmail,$membersdb,$subject,$content,$footer,$mailprog);
}
&actions if ($ENV{\'QUERY_STRING\'});
&print_login if ($ENV{\'REQUEST_METHOD\'} eq "GET");


sub actions {
my $enc_password = param("p");
my $action = param("a");
if ($enc_password eq $adminpassword) {
if ($action eq "list") {
&admin_list;
} elsif ($action eq "remove") {
&admin_remove;
} elsif ($action eq "add") {
&admin_add;
} elsif ($action eq "email") {
&admin_email;
} elsif ($action eq "config") {
&admin_config;
} elsif ($action eq "main") {
&admin_main2;
} elsif ($action eq "stats") {
&stats;
} elsif ($action eq "stats_s") {
&stats_s;
} elsif ($action eq "stats_l") {
&stats_l;
} elsif ($action eq "stats_b") {
&stats_b;
} elsif ($action eq "stats_u") {
&stats_u;
} elsif ($action eq "stats_a") {
&stats_a;
} elsif ($action eq "stats_r") {
&stats_r;
} elsif ($action eq "stats_i") {
&stats_i;
} else {
&print_login;
}
} else {
&admin_login_failed;
}
}


sub admin_list {
my $enc_password = param("p");
&count_users;
$font = "<font face=\"Arial\" size=\"1\">";
$efont = "</font>";
&header;
print "<tr><td colspan=2><font face=\"Arial\" size=\"2\"><b><a href=\"admin.cgi?a=main&p=$enc_password\">Top</a>: List All Users</b><br>Currently $user_count Registered Members</font><p><table border=\"0\" cellspacing=\"0\" cellpadding=\"1\" width=\"500\">\n";
print "<tr><td>$font Name $efont</td><td>$font Email $efont</td><td>$font Username $efont</td><td>$font $extra_field_name $efont</td><td>$font Date $efont</td></tr>\n";
$printnum="0";
my $start = param("n");
unless ($start) {
$start="0";
}
$records=$show_records;
$records=$records-1;
$finish=$start+$records;
open (DATA, "$membersdb") || warn "Locked Area Error: Cannot open database file: $!";
@indata = <DATA>;
close (DATA);
foreach $entries (@indata){
($name, $email, $username, $password, $extra, $date) = split(/\|/, $entries);

if (("$printnum" <= "$finish") && ("$printnum" >= "$start")) {
print "<tr><td>$font $name $efont</td><td>$font <a href=\"mailto:$email\">$email</a> $efont</td><td>$font $username $efont</td><td>$font";
if ($extra_url ne "1") {
print " $extra ";
} else {
print " <a href=\"$extra\">$extra</a> ";
}
print "$efont</td><td>$font $date $efont</td></tr>\n";
}
$printnum++;
}
$finish1 = $finish+1;
$finish2 = $start-$records-1;
print qq~
</table><br><center><font face="Arial" size="2">
~;
if ($finish2 ge 0) {
print qq~
<a href="admin.cgi?a=list&p=$enc_password&n=$finish2">Previous $show_records Records</a> 
~;
}
if (($finish2 ge 0) && ($printnum gt $finish1)) {
print " | \n";
}
if ($printnum gt $finish1) {
print qq~
<a href="admin.cgi?a=list&p=$enc_password&n=$finish1">Next $show_records Records</a>
~;
}
print qq~
</center></font><p>&nbsp;</td></tr>
<tr><td colspan=2><font face="Arial" size="1"><a href="admin.cgi?a=main&p=$enc_password">Main</a>
 : <a href="admin.cgi?a=list&p=$enc_password">List Users</a> : <a href="admin.cgi?a=add&p=$enc_password">Add User</a>
 : <a href="admin.cgi?a=remove&p=$enc_password">Delete Users</a> : <a href="admin.cgi?a=email&p=$enc_password">Bulk Email</a>
 : <a href="admin.cgi?a=config&p=$enc_password">Configuration</a> : <a href="admin.cgi?a=stats&p=$enc_password">Statistics</a>
 : <a href="http://$membersurl">My Member\'s Area</a></font></td></tr>
 ~;
&footer;
exit;
}

sub admin_add {
my $enc_password = param("p");
&header;
print qq~
<tr><td><font face="Arial" size="2"><b><a href="admin.cgi?a=main&p=$enc_password">Top</a>: Add New Account</b><br>
To add a new account to your member\'s area, please complete the below form.<br>
This form has the same entry requirements as locked.cgi, all fields are required with the exception of the extra custom field if it has been set as optional.  A welcome email will be sent when your click \'Create Account\'.
<p>
<form action="admin.cgi" method="post"><input type="hidden" name="add_user" value="yes"><input type="hidden" name="admin_password" value="$enc_password">
<center><table cellpadding=2 cellspacing=1 width=400>
<tr><td width=200><font face=Arial size=2><b>Username:</b></font></td><td><input type="text" name="username" size="25"></td></tr>
<tr><td width=200><font face=Arial size=2><b>Password:</b></font></td><td><input type="password" name="password" size="25"></td></tr>
<tr><td width=200><font face=Arial size=2><b>Confirm Password:</b></font></td><td><input type="password" name="password2" size="25"></td></tr>
<tr><td width=200><font face=Arial size=2><b>Email Address:</b></font></td><td><input type="text" name="email" size="25"></td></tr>
<tr><td width=200><font face=Arial size=2><b>Full Name:</b></font></td><td><input type="text" name="name" size="25"></td></tr>
<tr><td width=200><font face=Arial size=2><b>$extra_field_name:</b></font></td><td><input type="text" name="extra" size="25"></td></tr>
 
<tr><td width=200><font face=Arial size=2></font></td><td align=center><input type=submit name="submit" value="Create Account"></td></tr>
</table></form></font></td></tr>

<tr><td colspan=2><font face="Arial" size="1"><a href="admin.cgi?a=main&p=$enc_password">Main</a>
 : <a href="admin.cgi?a=list&p=$enc_password">List Users</a> : <a href="admin.cgi?a=add&p=$enc_password">Add User</a>
 : <a href="admin.cgi?a=remove&p=$enc_password">Delete Users</a> : <a href="admin.cgi?a=email&p=$enc_password">Bulk Email</a>
 : <a href="admin.cgi?a=config&p=$enc_password">Configuration</a> : <a href="admin.cgi?a=stats&p=$enc_password">Statistics</a>
 : <a href="http://$membersurl">My Member\'s Area</a></font></td></tr>
~;
&footer;
exit;
}

sub add_user {
$username = $query->param(\'username\');
$password = $query->param(\'password\');
$password2 = $query->param(\'password2\');
$email1 = $query->param(\'email\');
$name = $query->param(\'name\');
$extra1 = $query->param(\'extra\');

$enc_password = $query->param(\'admin_password\');
if ($enc_password eq $adminpassword) {
$password1=$password;
$usernameok = $username if (length($username) > 6);
$passwordok = $password if (($password eq $password2) && (length($password) > 6));

$emailok = $email1;

if ($extra_url eq "1") {
$extra = $extra1 if (substr($extra1,0,7) eq \'http://\'); # URL validation check if wanted.
} else { $extra = $extra1 }

# This checks all fields have been filled in.
if ($extra_required eq "1") {
unless ($usernameok && $passwordok && $emailok && $name && $extra) {
&header;
print qq~
<tr><td><font face="Arial" size="2"><b><a href="admin.cgi?a=main&p=$enc_password">Top</a>: Add New Account Error</b><br>
An error occured when trying to create the account.
<font face=$fontface size=$fontsize color=#FF0000><ul>
~;
	print "<li>Either you didn\'t enter a username or it was less than 6 characters in length.<br>" unless ($usernameok);
	print "" unless ($usernameok && $emailok);
	print "<li>Either you didn\'t enter a password or it was less than 6 characters in length.<br>" unless ($passwordok);
	print "" unless ($usernameok && $emailok);
	print "<li>Either you didn\'t enter a email address or the email address you entered didn\'t match your confirm email address<br>" unless ($emailok);
	print "" unless ($emailok && $agree);
	print "<li>You did not enter your full name.<br>" unless ($name);
	print "" unless ($emailok && $agree);
	print "<li>You did not enter your $extra_field_name.<br>" unless ($extra);
	print qq~
</ul></font>
<p>
<form action="admin.cgi" method="post"><input type="hidden" name="add_user" value="yes"><input type="hidden" name="admin_password" value="$enc_password">
<center><table cellpadding=2 cellspacing=1 width=400>
<tr><td width=200><font face=Arial size=2><b>Username:</b></font></td><td><input type="text" name="username" size="25" value="$usernameok"></td></tr>
<tr><td width=200><font face=Arial size=2><b>Password:</b></font></td><td><input type="password" name="password" size="25" value="$passwordok"></td></tr>
<tr><td width=200><font face=Arial size=2><b>Confirm Password:</b></font></td><td><input type="password" name="password2" value="$passwordok" size="25"></td></tr>
<tr><td width=200><font face=Arial size=2><b>Email Address:</b></font></td><td><input type="text" name="email" size="25" value="$emailok"></td></tr>
<tr><td width=200><font face=Arial size=2><b>Full Name:</b></font></td><td><input type="text" name="name" size="25" value="$name"></td></tr>
<tr><td width=200><font face=Arial size=2><b>$extra_field_name:</b></font></td><td><input type="text" name="extra" size="25" value="$extra"></td></tr>
<tr><td width=200><font face=Arial size=2></font></td><td align=center><input type=submit name="submit" value="Create Account"></td></tr>
</table></form></font></td></tr>
<tr><td colspan=2><font face="Arial" size="1"><a href="admin.cgi?a=main&p=$enc_password">Main</a>
 : <a href="admin.cgi?a=list&p=$enc_password">List Users</a> : <a href="admin.cgi?a=add&p=$enc_password">Add User</a>
 : <a href="admin.cgi?a=remove&p=$enc_password">Delete Users</a> : <a href="admin.cgi?a=email&p=$enc_password">Bulk Email</a>
 : <a href="admin.cgi?a=config&p=$enc_password">Configuration</a> : <a href="admin.cgi?a=stats&p=$enc_password">Statistics</a>
 : <a href="http://$membersurl">My Member\'s Area</a></font></td></tr>
~;
&footer;
exit;
}
} else {
unless ($usernameok && $passwordok && $emailok && $name) {
&header;
print qq~
<tr><td><font face="Arial" size="2"><b><a href="admin.cgi?a=main&p=$enc_password">Top</a>: Add New Account Error</b><br>
An error occured when trying to create the account.
<font face=$fontface size=$fontsize color=#FF0000><ul>
~;
	print "<li>Either you didn\'t enter a username or it was less than 6 characters in length.<br>" unless ($usernameok);
	print "" unless ($usernameok && $emailok);
	print "<li>Either you didn\'t enter a password or it was less than 6 characters in length.<br>" unless ($passwordok);
	print "" unless ($usernameok && $emailok);
	print "<li>Either you didn\'t enter a email address or the email address you entered didn\'t match your confirm email address<br>" unless ($emailok);
	print "" unless ($emailok && $agree);
	print "<li>You did not enter your full name.<br>" unless ($name);
	print qq~
</ul></font>
<p>
<form action="admin.cgi" method="post"><input type="hidden" name="add_user" value="yes"><input type="hidden" name="admin_password" value="$enc_password">
<center><table cellpadding=2 cellspacing=1 width=400>
<tr><td width=200><font face=Arial size=2><b>Username:</b></font></td><td><input type="text" name="username" size="25" value="$usernameok"></td></tr>
<tr><td width=200><font face=Arial size=2><b>Password:</b></font></td><td><input type="password" name="password" size="25" value="$passwordok"></td></tr>
<tr><td width=200><font face=Arial size=2><b>Confirm Password:</b></font></td><td><input type="password" name="password2" value="$passwordok" size="25"></td></tr>
<tr><td width=200><font face=Arial size=2><b>Email Address:</b></font></td><td><input type="text" name="email" size="25" value="$emailok"></td></tr>
<tr><td width=200><font face=Arial size=2><b>Full Name:</b></font></td><td><input type="text" name="name" size="25" value="$name"></td></tr>
<tr><td width=200><font face=Arial size=2><b>$extra_field_name:</b></font></td><td><input type="text" name="extra" size="25" value="$extra"></td></tr>
<tr><td width=200><font face=Arial size=2></font></td><td align=center><input type=submit name="submit" value="Create Account"></td></tr>
</table></form></font></td></tr>
<tr><td colspan=2><font face="Arial" size="1"><a href="admin.cgi?a=main&p=$enc_password">Main</a>
 : <a href="admin.cgi?a=list&p=$enc_password">List Users</a> : <a href="admin.cgi?a=add&p=$enc_password">Add User</a>
 : <a href="admin.cgi?a=remove&p=$enc_password">Delete Users</a> : <a href="admin.cgi?a=email&p=$enc_password">Bulk Email</a>
 : <a href="admin.cgi?a=config&p=$enc_password">Configuration</a> : <a href="admin.cgi?a=stats&p=$enc_password">Statistics</a>
 : <a href="http://$membersurl">My Member\'s Area</a></font></td></tr>
~;
&footer;
exit;
}
}

# This checks if email address is in correct format.
if ($emailok =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)/ || $emailok !~ /^.+\@(\[?)[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,4}|[0-9]{1,3})(\]?)$/) {
&header;
print qq~
<tr><td><font face="Arial" size="2"><b><a href="admin.cgi?a=main&p=$enc_password">Top</a>: Add New Account Error</b><br>
An error occured when trying to create the account.
<font face=$fontface size=$fontsize color=#FF0000><ul>
<li>The email address entered was in an incorrect format and was not accepted.<br>
</ul></font>
<p>
<form action="admin.cgi" method="post"><input type="hidden" name="add_user" value="yes"><input type="hidden" name="admin_password" value="$enc_password">
<center><table cellpadding=2 cellspacing=1 width=400>
<tr><td width=200><font face=Arial size=2><b>Username:</b></font></td><td><input type="text" name="username" size="25" value="$usernameok"></td></tr>
<tr><td width=200><font face=Arial size=2><b>Password:</b></font></td><td><input type="password" name="password" size="25" value="$passwordok"></td></tr>
<tr><td width=200><font face=Arial size=2><b>Confirm Password:</b></font></td><td><input type="password" name="password2" value="$passwordok" size="25"></td></tr>
<tr><td width=200><font face=Arial size=2><b>Email Address:</b></font></td><td><input type="text" name="email" size="25"></td></tr>
<tr><td width=200><font face=Arial size=2><b>Full Name:</b></font></td><td><input type="text" name="name" size="25" value="$name"></td></tr>
<tr><td width=200><font face=Arial size=2><b>$extra_field_name:</b></font></td><td><input type="text" name="extra" size="25" value="$extra"></td></tr>
<tr><td width=200><font face=Arial size=2></font></td><td align=center><input type=submit name="submit" value="Create Account"></td></tr>
</table></form></font></td></tr>
<tr><td colspan=2><font face="Arial" size="1"><a href="admin.cgi?a=main&p=$enc_password">Main</a>
 : <a href="admin.cgi?a=list&p=$enc_password">List Users</a> : <a href="admin.cgi?a=add&p=$enc_password">Add User</a>
 : <a href="admin.cgi?a=remove&p=$enc_password">Delete Users</a> : <a href="admin.cgi?a=email&p=$enc_password">Bulk Email</a>
 : <a href="admin.cgi?a=config&p=$enc_password">Configuration</a> : <a href="admin.cgi?a=stats&p=$enc_password">Statistics</a>
 : <a href="http://$membersurl">My Member\'s Area</a></font></td></tr>
~;
&footer;
exit;

}

$usernameok =~ s/\|//g;
$passwordok =~ s/\|//g;
$emailok =~ s/\|//g;
$name =~ s/\|//g;
$extra =~ s/\|//g; 

$usernameok =~ s/\://g;
$passwordok =~ s/\://g;

# Check is email address already has account.
open (DATABASEM, "$membersdb");
@wholebasem = <DATABASEM>;
close (DATABASEM);
foreach $olduserm (@wholebasem) {
	chomp ($olduserm);
	# db looks like username|password|email|etc...
	@userm = split(/\|/, $olduserm);
	# check for duplicate email address in members db
	if ($emailok eq $userm[1]) {
&header;
print qq~
<tr><td><font face="Arial" size="2"><b><a href="admin.cgi?a=main&p=$enc_password">Top</a>: Add New Account Error</b><br>
An error occured when trying to create the account.
<font face=$fontface size=$fontsize color=#FF0000><ul>
<li>An account already exists for this email address with the username, $userm[2].<br>
</ul></font>
<p>
<form action="admin.cgi" method="post"><input type="hidden" name="add_user" value="yes"><input type="hidden" name="admin_password" value="$enc_password">
<center><table cellpadding=2 cellspacing=1 width=400>
<tr><td width=200><font face=Arial size=2><b>Username:</b></font></td><td><input type="text" name="username" size="25" value="$usernameok"></td></tr>
<tr><td width=200><font face=Arial size=2><b>Password:</b></font></td><td><input type="password" name="password" size="25" value="$passwordok"></td></tr>
<tr><td width=200><font face=Arial size=2><b>Confirm Password:</b></font></td><td><input type="password" name="password2" value="$passwordok" size="25"></td></tr>
<tr><td width=200><font face=Arial size=2><b>Email Address:</b></font></td><td><input type="text" name="email" size="25"></td></tr>
<tr><td width=200><font face=Arial size=2><b>Full Name:</b></font></td><td><input type="text" name="name" size="25" value="$name"></td></tr>
<tr><td width=200><font face=Arial size=2><b>$extra_field_name:</b></font></td><td><input type="text" name="extra" size="25" value="$extra"></td></tr>
<tr><td width=200><font face=Arial size=2></font></td><td align=center><input type=submit name="submit" value="Create Account"></td></tr>
</table></form></font></td></tr>
<tr><td colspan=2><font face="Arial" size="1"><a href="admin.cgi?a=main&p=$enc_password">Main</a>
 : <a href="admin.cgi?a=list&p=$enc_password">List Users</a> : <a href="admin.cgi?a=add&p=$enc_password">Add User</a>
 : <a href="admin.cgi?a=remove&p=$enc_password">Delete Users</a> : <a href="admin.cgi?a=email&p=$enc_password">Bulk Email</a>
 : <a href="admin.cgi?a=config&p=$enc_password">Configuration</a> : <a href="admin.cgi?a=stats&p=$enc_password">Statistics</a>
 : <a href="http://$membersurl">My Member\'s Area</a></font></td></tr>
~;
&footer;
exit;
	}
# Checks for duplicate username in members db
	if ($usernameok eq $userm[2]) {
&header;
print qq~
<tr><td><font face="Arial" size="2"><b><a href="admin.cgi?a=main&p=$enc_password">Top</a>: Add New Account Error</b><br>
An error occured when trying to create the account.
<font face=$fontface size=$fontsize color=#FF0000><ul>
<li>An account already exists with the username you have chosen.<br>
</ul></font>
<p>
<form action="admin.cgi" method="post"><input type="hidden" name="add_user" value="yes"><input type="hidden" name="admin_password" value="$enc_password">
<center><table cellpadding=2 cellspacing=1 width=400>
<tr><td width=200><font face=Arial size=2><b>Username:</b></font></td><td><input type="text" name="username" size="25"></td></tr>
<tr><td width=200><font face=Arial size=2><b>Password:</b></font></td><td><input type="password" name="password" size="25" value="$passwordok"></td></tr>
<tr><td width=200><font face=Arial size=2><b>Confirm Password:</b></font></td><td><input type="password" name="password2" value="$passwordok" size="25"></td></tr>
<tr><td width=200><font face=Arial size=2><b>Email Address:</b></font></td><td><input type="text" name="email" size="25" value="$emailok"></td></tr>
<tr><td width=200><font face=Arial size=2><b>Full Name:</b></font></td><td><input type="text" name="name" size="25" value="$name"></td></tr>
<tr><td width=200><font face=Arial size=2><b>$extra_field_name:</b></font></td><td><input type="text" name="extra" size="25" value="$extra"></td></tr>
<tr><td width=200><font face=Arial size=2></font></td><td align=center><input type=submit name="submit" value="Create Account"></td></tr>
</table></form></font></td></tr>
<tr><td colspan=2><font face="Arial" size="1"><a href="admin.cgi?a=main&p=$enc_password">Main</a>
 : <a href="admin.cgi?a=list&p=$enc_password">List Users</a> : <a href="admin.cgi?a=add&p=$enc_password">Add User</a>
 : <a href="admin.cgi?a=remove&p=$enc_password">Delete Users</a> : <a href="admin.cgi?a=email&p=$enc_password">Bulk Email</a>
 : <a href="admin.cgi?a=config&p=$enc_password">Configuration</a> : <a href="admin.cgi?a=stats&p=$enc_password">Statistics</a>
 : <a href="http://$membersurl">My Member\'s Area</a></font></td></tr>
~;
&footer;
exit;
	}
}

&get_date;
# Encrypts password, opens db, locks it, writes to it, closes it.  Adds user to members.db basically.
$db_password = crypt($passwordok, "La");
open (DATABASE, ">>$membersdb") || warn "Locked Area Error: Cannot open database file: $!";
flock (DATABASE, LOCK_EX) || warn "Locked Area Error: Cannot flock database.  $!";
print DATABASE "$name|$emailok|$usernameok|$db_password|$extra|$date\n";
close (DATABASE);

# Encrypts password, opens password file, locks it, writes to it, closes it.  Adds user to password file basically.
$lasalt = &salt;
$enc_password1 = crypt($passwordok, "$lasalt");
open (HTPASSWD, ">>$htpasswd") || warn "Locked Area Error: Cannot open htpasswd file: $!";
flock (HTPASSWD, LOCK_EX) || warn "Locked Area Error: Cannot flock htpasswd file.  $!";
print HTPASSWD "$usernameok:$enc_password1\n";
close (HTPASSWD);

# Send welcome email.
require "mails.pl";

&header;
print qq~
<tr><td><font face="Arial" size="2"><b><a href="admin.cgi?a=main&p=$enc_password">Top</a>: Account Created Successfully</b><br>
The account has been successfully created.<p>
<b>Username:</b> $usernameok<br>
<b>Password:</b> $passwordok<br>
<b>Email Address:</b> $emailok<br>
<b>Full Name:</b> $name<br>
<b>$extra_field_name:</b> $extra<p>
&nbsp;
</font></td></tr>
<tr><td colspan=2><font face="Arial" size="1"><a href="admin.cgi?a=main&p=$enc_password">Main</a>
 : <a href="admin.cgi?a=list&p=$enc_password">List Users</a> : <a href="admin.cgi?a=add&p=$enc_password">Add User</a>
 : <a href="admin.cgi?a=remove&p=$enc_password">Delete Users</a> : <a href="admin.cgi?a=email&p=$enc_password">Bulk Email</a>
 : <a href="admin.cgi?a=config&p=$enc_password">Configuration</a> : <a href="admin.cgi?a=stats&p=$enc_password">Statistics</a>
 : <a href="http://$membersurl">My Member\'s Area</a></font></td></tr>
~;
&footer;
exit;

} else {
&admin_login_failed;
}
}

sub admin_remove {
my $enc_password = param("p");
&header;
print qq~
<tr><td><font face="Arial" size="2"><b><a href="admin.cgi?a=main&p=$enc_password">Top</a>: Remove Account</b><br>Please enter a username to remove that users account.  This will permanantly remove the account.<p>
<form action="admin.cgi" method="post"><input type="hidden" name="remove_user" value="yes"><input type="hidden" name="admin_password" value="$enc_password">
<center><table cellpadding=2 cellspacing=1 width=490><tr><td width=300><font face=Arial size=2><b>Username:</b>&nbsp; <input type="text" name="remove_username"><br>
</font></td><td><input type=submit name="submit" value="Remove User"></td></tr></table></form></font></td></tr>
<tr><td colspan=2><font face="Arial" size="1"><a href="admin.cgi?a=main&p=$enc_password">Main</a>
 : <a href="admin.cgi?a=list&p=$enc_password">List Users</a> : <a href="admin.cgi?a=add&p=$enc_password">Add User</a>
 : <a href="admin.cgi?a=remove&p=$enc_password">Delete Users</a> : <a href="admin.cgi?a=email&p=$enc_password">Bulk Email</a>
 : <a href="admin.cgi?a=config&p=$enc_password">Configuration</a> : <a href="admin.cgi?a=stats&p=$enc_password">Statistics</a>
 : <a href="http://$membersurl">My Member\'s Area</a></font></td></tr>
~;
&footer;
exit;
}

sub remove_user {
$remove_username = $query->param(\'remove_username\');
$enc_password = $query->param(\'admin_password\');
if ($enc_password eq $adminpassword) {
	open (DATA, "$membersdb") || warn "Locked Area Error: Cannot open database file: $!";
	@indata = <DATA>;
	close (DATA);
	foreach $entries (@indata){
		($name, $email, $username, $password, $extra, $date) = split(/\|/, $entries);
		if ($username eq $remove_username) {
			$found = 1;

			last;
		}
	}
	unless ($found) {
&header;
print qq~
<tr><td colspan=2><font face="Arial" size=2><b><a href="admin.cgi?a=main&p=$enc_password">Top</a>: Account Removal Failed</b><br>
Username, <b>$user</b> was not found in the database.
</font></td></tr>
<tr><td colspan=2><font face="Arial" size="1"><a href="admin.cgi?a=main&p=$enc_password">Main</a>
 : <a href="admin.cgi?a=list&p=$enc_password">List Users</a> : <a href="admin.cgi?a=add&p=$enc_password">Add User</a>
 : <a href="admin.cgi?a=remove&p=$enc_password">Delete Users</a> : <a href="admin.cgi?a=email&p=$enc_password">Bulk Email</a>
 : <a href="admin.cgi?a=config&p=$enc_password">Configuration</a> : <a href="admin.cgi?a=stats&p=$enc_password">Statistics</a>
 : <a href="http://$membersurl">My Member\'s Area</a></font></td></tr>
~;
&footer;
exit;
		}

	open (WRITEDATA, ">$membersdb") || warn "Locked Area Error: Cannot open database file: $!";
	flock (WRITEDATA, LOCK_EX) || warn "Locked Area Error: Cannot flock database.  $!";
	foreach $memberline (@indata) {
		($name, $email, $username, $password, $extra, $date) = split(/\|/, $memberline);
		if ($username eq $remove_username) {
		} else {
			print WRITEDATA $memberline;
		}
	}
	close (WRITEDATA);
	open (READHT, "$htpasswd");
	@htpw = <READHT>;
	close (READHT);
	open (WRITEHT, ">$htpasswd") || warn "Locked Area Error: Cannot open password file: $!";
	flock (WRITEHT, LOCK_EX) || warn "Locked Area Error: Cannot flock password file.  $!";
	foreach $passline (@htpw) {
		($htuser, $htpass) = split(/\:/, $passline);
		if ($htuser eq $remove_username) {
		} else {
			print WRITEHT $passline;
		}
	}
	close (WRITEHT);

&header;
print qq~
<tr><td colspan=2><b><a href="admin.cgi?a=main&p=$enc_password">Top</a>: Account Removed</b><br>
The following account(s) have been removed:<p>
<b>$remove_username</b>
</font></td></tr>
<tr><td colspan=2><font face="Arial" size="1"><a href="admin.cgi?a=main&p=$enc_password">Main</a>
 : <a href="admin.cgi?a=list&p=$enc_password">List Users</a> : <a href="admin.cgi?a=add&p=$enc_password">Add User</a>
 : <a href="admin.cgi?a=remove&p=$enc_password">Delete Users</a> : <a href="admin.cgi?a=email&p=$enc_password">Bulk Email</a>
 : <a href="admin.cgi?a=config&p=$enc_password">Configuration</a> : <a href="admin.cgi?a=stats&p=$enc_password">Statistics</a>
 : <a href="http://$membersurl">My Member\'s Area</a></font></td></tr>
~;
&footer;
exit;
} else {
&admin_login_failed;
}
}

sub admin_email {
my $enc_password = param("p");
&header;
print qq~
<tr><td colspan=2><font face="Arial" size="2"><b><a href="admin.cgi?a=main&p=$enc_password">Top</a>: Bulk Email Users</b><br>
To send a bulk mailing to all your member\'s, please complete the below form and click \'Submit\'.  If you want to include data from the member\'s database in your mailing, you can do so using the following tags which may be used in the message subject, main content and footer text.<br>
<b>Username:</b> &lt;%Username%&gt;<br><b>Full Name:</b> &lt;%Name%&gt;<br><b>Email Address:</b> &lt;%Email%&gt;<br><b>Custom Field, $extra_field_name:</b> &lt;%Extra%&gt;<br><b>Registration Date:</b> &lt;%Date%&gt;<br>
<form method="post" action="admin.cgi">
<input type="hidden" name="admin_password" value="$enc_password">
<input type="hidden" name="send_email" value="yes">
<table border="0" cellspacing="0" width="500">
<tr><td width="137"><font face="Arial" size="2"><b>Message Subject:</b></font></td>
<td width="347"><font face="Arial" size="2"><input type="text" name="subject" size="40"></font></td></tr>
<tr><td width="137"><font face="Arial" size="2"><b>Message Content:</b></font></td>
<td width="347"></td></tr>
<tr><td colspan="2" width="492"><p align="center"><textarea rows="11" name="content" cols="56"></textarea></td></tr>
<tr><td width="137"><font face="Arial" size="2"><b>Footer:</b></font></td><td width="347"> </td></tr>
<tr><td colspan="2" width="492"><p align="center"><textarea rows="3" name="footer" cols="56">--
You are receiving this mailing because you or someone using your email address registered to join $sitename.
If you wish to remove your acount and be unsubscribed from future mailings please go to the url below:
$cgiurl/locked.cgi?delete</textarea></td></tr>
<tr><td width="484" colspan="2"><font face="Arial" size="1">When you click Submit the above message will be sent to all the email addresses in your 
members database.&nbsp; If you receive an error from this script upon clicking Submit do not click again, if you are a member of your own 
member\'s area, check your email.&nbsp; You will probably find that the emails have been sent but the server has timed out your request to use 
this cgi script.&nbsp; If you do receive the email then all users should have, otherwise try running another mailing.  If it fails repeatedly please contact your system administrator.</font></td>
</tr><tr><td width="137"></td><td width="347">
<p align="center"><font face="Arial" size="2"><input type="submit" value="Submit"><input type="reset" value="Reset" name="reset"></font></td>
</tr></table></form></font></td></tr>
<tr><td colspan=2><font face="Arial" size="1"><a href="admin.cgi?a=main&p=$enc_password">Main</a>
 : <a href="admin.cgi?a=list&p=$enc_password">List Users</a> : <a href="admin.cgi?a=add&p=$enc_password">Add User</a>
 : <a href="admin.cgi?a=remove&p=$enc_password">Delete Users</a> : <a href="admin.cgi?a=email&p=$enc_password">Bulk Email</a>
 : <a href="admin.cgi?a=config&p=$enc_password">Configuration</a> : <a href="admin.cgi?a=stats&p=$enc_password">Statistics</a>
 : <a href="http://$membersurl">My Member\'s Area</a></font></td></tr>
~;
&footer;
exit;
}

sub send_email {
$enc_password = $query->param(\'admin_password\');
my ($username);
my ($email);
my ($name);
my ($date);
my ($extra);
if ($enc_password eq $adminpassword) {
	my ($adminmail,$membersdb,$subject,$content,$footer,$mailprog) = @_;
	$asubject=$subject;
	$acontent=$content;
	$afooter=$footer;
	$email_count = 0;
	open (DATA, "$membersdb") || warn "Locked Area Error: Cannot open database file: $!";
	@indata = <DATA>;
	close (DATA);
	foreach $entries (@indata){
	$subject=$asubject;
	$content=$acontent;
	$footer=$afooter;
		($name, $email, $username, $password, $extra, $date) = split(/\|/, $entries);
	$subject =~ s/<%Username%>/$username/g;
	$subject =~ s/<%Email%>/$email/g;
	$subject =~ s/<%Name%>/$name/g;
	$subject =~ s/<%Date%>/$date/g;
	$subject =~ s/<%Extra%>/$extra/g;
	$content =~ s/<%Username%>/$username/g;
	$content =~ s/<%Email%>/$email/g;
	$content =~ s/<%Name%>/$name/g;
	$content =~ s/<%Date%>/$date/g;
	$content =~ s/<%Extra%>/$extra/g;
	$footer =~ s/<%Username%>/$username/g;
	$footer =~ s/<%Email%>/$email/g;
	$footer =~ s/<%Name%>/$name/g;
	$footer =~ s/<%Date%>/$date/g;
	$footer =~ s/<%Extra%>/$extra/g;
		open (MAILEM, "|$mailprog -t") or &dienice("Can\'t access $mailprog!\n");
		print MAILEM "To: $email\n";
		print MAILEM "From: $adminmail\n";
		print MAILEM "Subject: $subject\n\n";
		print MAILEM qq~$content\n$footer\nUsername: $username~;
		close (MAILEM);
		$email_count++;
	}
&header;
print qq~
<tr><td colspan=2>
<font face="Arial" size="2"><b><a href="admin.cgi?a=main&p=$enc_password">Top</a>: $email_count Emails Sent</b><br>
The following message has been sent:<p>
<b>Subject:</b> $subject<br>
<b>Content:</b><br>
$content<br>
$footer<p>
Please note, the data from the member\'s db you see in the above message is that of the last user to be emailed.
</td></tr>
<tr><td colspan=2><font face="Arial" size="1"><a href="admin.cgi?a=main&p=$enc_password">Main</a>
 : <a href="admin.cgi?a=list&p=$enc_password">List Users</a> : <a href="admin.cgi?a=add&p=$enc_password">Add User</a>
 : <a href="admin.cgi?a=remove&p=$enc_password">Delete Users</a> : <a href="admin.cgi?a=email&p=$enc_password">Bulk Email</a>
 : <a href="admin.cgi?a=config&p=$enc_password">Configuration</a> : <a href="admin.cgi?a=stats&p=$enc_password">Statistics</a>
 : <a href="http://$membersurl">My Member\'s Area</a></font></td></tr>
~;
&footer;
exit;
} else {
&admin_login_failed;
}
}
sub admin_config {
my $enc_password = param("p");

&header;
print qq~
<tr><td colspan=2><font face="Arial" size="2"><b><a href="admin.cgi?a=main&p=$enc_password">Top</a>: Configuration</b><br>
<form action="admin.cgi" method="post">
<input type="hidden" name="update_config" value="yes">
<input type="hidden" name="enc_password" value="$enc_password">
<table border="0" cellpadding=1 cellspacing="0" width="500">
  <tr>
    <td><font face="Arial" size="2"><b>Member\'s Area Name:</b><br>
      </font><font face="Arial" size="1">The name of your member\'s area.<br>
      e.g. LockedArea.com Member\'s Area.</font></td>
    <td><input type="text" name="sitename" size="30" value="$sitename"></td>
  </tr>
  <tr>
    <td bgcolor="#000080" height="1"></td>
    <td bgcolor="#000080" height="1"></td>
  </tr>
  <tr>
    <td><font face="Arial" size="2"><b>Members Database:<br>
      </b></font><font face="Arial" size="1">The location of your members
      database.&nbsp; It must be a full path and must end with a filename.<br>
      e.g. /home/username/dir/members.db</font></td>
    <td><input type="text" name="membersdb" size="30" value="$membersdb"></td>
  </tr>
  <tr>
    <td><font face="Arial" size="2"><b>Password File:<br>
      </b></font><font face="Arial" size="1">The location of your password file
      for use with your .htaccess file.&nbsp; It\'s recommended you call this .htpasswd.&nbsp;
      You must enter a full path that ends with a filename.<br>
      e.g. /home/username/members/.htpasswd</font></td>
    <td><input type="text" name="htpasswd" size="30" value="$htpasswd"></td>
  </tr>
  <tr>
    <td><font face="Arial" size="2"><b>Htaccess File:<br>
      </b></font><font face="Arial" size="1">The location of your .htaccess
      file.&nbsp; This must be in your member\'s area directory.&nbsp; You must
      enter a full path that ends with a filename.<br>
      e.g. /home/username/members/.htaccess</font></td>
    <td><input type="text" name="htaccess" size="30" value="$htaccess"></td>
  </tr>
  <tr>
    <td bgcolor="#000080" height="1"></td>
    <td bgcolor="#000080" height="1"></td>
  </tr>
  <tr>
    <td><font face="Arial" size="2"><b>Extra Field Name:<br>
      </b></font><font face="Arial" size="1">The last field on the locked.cgi
      registration form is optional.&nbsp; It doesn\'t have to be a URL field if
      you don\'t want it to be.&nbsp; Please enter the name for this field.<br>
      e.g. Occupation or Comments.</font></td>
    <td><input type="text" name="extra_field_name" size="30" value="$extra_field_name"></td>
  </tr>
  <tr>
    <td><font face="Arial" size="2"><b>Extra Field URL?<br>
      </b></font><font face="Arial" size="1">Do you wish to use the extra field
      in the locked.cgi registration form to record URLs?&nbsp; If so, tick this
      and all entries will be verified as starting with http://.  If you wish to use
      the url format checking you must set the field as required below.</font></td>
      ~;
if ($extra_url eq "1"){
    print "<td><input type=\"checkbox\" name=\"extra_url\" value=\"1\" checked></td>\n";
    } else {
    print "<td><input type=\"checkbox\" name=\"extra_url\" value=\"1\"></td>\n";
}
	  print qq~
  </tr>
  <tr>
    <td><font face="Arial" size="2"><b>Extra Field Required?<br>
      </b></font><font face="Arial" size="1">Do you want the extra field to be required?  This means during registration, the registra must enter a value for this field.&nbsp; If so, please select/tick
       the below tickbox.  You must select this option if you wish to use the url format checking.</font></td>
      ~;
if ($extra_required eq "1"){
    print "<td><input type=\"checkbox\" name=\"extra_required\" value=\"1\" checked></td>\n";
    } else {
    print "<td><input type=\"checkbox\" name=\"extra_required\" value=\"1\"></td>\n";
}
	  print qq~
  </tr>  
  <tr>
    <td bgcolor="#000080" height="1"></td>
    <td bgcolor="#000080" height="1"></td>
  </tr>
  <tr>
    <td><font face="Arial" size="2"><b>Mail Program:<br>
      </b></font><font face="Arial" size="1">The location of sendmail on your
      web server.<br>
      e.g. /usr/sbin/sendmail</font></td>
    <td><input type="text" name="mailprog" size="30" value="$mailprog"></td>
  </tr>
  <tr>
    <td><font face="Arial" size="2"><b>New Member Email:<br>
      </b></font><font face="Arial" size="1">Do you wish to be notified by email
      every time a user registers?&nbsp; Tick for yes.</font></td>
      ~;
if ($newmemberemail eq "1"){
    print "<td><input type=\"checkbox\" name=\"newmemberemail\" value=\"1\" checked></td>\n";
    } else {
    print "<td><input type=\"checkbox\" name=\"newmemberemail\" value=\"1\"></td>\n";
}
	  print qq~
  </tr>
  <tr>
    <td><font face="Arial" size="2"><b>User Remove Email:<br>
      </b></font><font face="Arial" size="1">Do you wish to be notified every
      time a user deletes their account?&nbsp; Tick for yes.</font></td>
      ~;
if ($removeemail eq "1"){
    print "<td><input type=\"checkbox\" name=\"removeemail\" value=\"1\" checked></td>\n";
    } else {
    print "<td><input type=\"checkbox\" name=\"removeemail\" value=\"1\"></td>\n";
}
	  print qq~
  </tr>
  <tr>
    <td bgcolor="#000080" height="1"></td>
    <td bgcolor="#000080" height="1"></td>
  </tr>
  <tr>
    <td><font face="Arial" size="2"><b>Admin Name:<br>
      </b></font><font face="Arial" size="1">The name of the administrator for
      your member\'s area.&nbsp; This name is included in all outgoing email.</font></td>
    <td><input type="text" name="adminname" size="30" value="$adminname"></td>
  </tr>
  <tr>
    <td><font face="Arial" size="2"><b>Admin Email Address:<br>
      </b></font><font face="Arial" size="1">The email address of the
      administrator.&nbsp; This email address is used as the sender of all email
      sent by this script.  YOU MUST PUT A \ BEFORE THE \@ SIGN!<br>
      e.g. you\@yourname.com</font></td>
    <td><input type="text" name="adminmail" size="30" value="$adminmail"></td>
  </tr>
  <tr>
    <td><font face="Arial" size="2"><b>Administrator Password:<br>
      </b></font><font face="Arial" size="1">If you do not wish to change your
      password, leave this field blank.&nbsp; If you wish to change it enter
      your new password here.</font></td>
    <td><input type="text" name="adminpassword" size="30" value=""></td>
  </tr>
  <tr>
    <td><font face="Arial" size="2"><b>Records to List:<br>
      </b></font><font face="Arial" size="1">When listing all accounts in the \'List Users\' section of the admin panel, how many records would you like to view per/page?</font></td>
    <td><input type="text" name="show_records" size="4" value="$show_records"></td>
  </tr>
  <tr>
    <td bgcolor="#000080" height="1"></td>
    <td bgcolor="#000080" height="1"></td>
  </tr>
  <tr>
    <td><font face="Arial" size="2"><b>Images URL:<br>
      </b></font><font face="Arial" size="1">The URL to the directory with the
      Locked Area Lite images in.&nbsp; You must enter a full URL but do not end
      it with a trailing slash.<br>
      e.g. http://www.yourdomain.com/images</font></td>
    <td><input type="text" name="imageurl" size="30" value="$imageurl"></td>
  </tr>
  <tr>
    <td><font face="Arial" size="2"><b>CGI-Bin URL:<br>
      </b></font><font face="Arial" size="1">The URL to the directory with the
      Locked Area Lite cgi script in.&nbsp; You must enter a full URL but do not
      end it with a trailing slash.<br>
      e.g. http://www.yourdomain.com/cgi-bin/la</font></td>
    <td><input type="text" name="cgiurl" size="30" value="$cgiurl"></td>
  </tr>
  <tr>
    <td><font face="Arial" size="2"><b>Members Area URL:<br>
      </b></font><font face="Arial" size="1">The URL to your member\'s
      area.&nbsp; Do not start it with http:// (miss that part off) but you can
      end it with a trailing slash or filename if you wish.<br>
      e.g. www.yourdomain.com/members/index.html</font></td>
    <td><input type="text" name="membersurl" size="30" value="$membersurl"></td>
  </tr>
  <tr>
    <td bgcolor="#000080" height="1"></td>
    <td bgcolor="#000080" height="1"></td>
  </tr>
  <tr>
    <td><font face="Arial" size="2"><b>Terms and Conditions:<br>
      </b></font><font face="Arial" size="1">The terms and conditions displayed
      on your registration page.&nbsp; You may use HTML tags.</font></td>
    <td>
      <p align="center"><textarea rows="4" name="terms" cols="23">$terms</textarea></td>
  </tr>
  <tr>
    <td bgcolor="#000080" height="1"></td>
    <td bgcolor="#000080" height="1"></td>
  </tr>
  <tr>
    <td><font face="Arial" size="2"><b>Table Header Colour:<br>
      </b></font><font face="Arial" size="1">The colour used for the headers in
      locked.cgi.&nbsp; i.e. the top bar that is grey by default.</font></td>
    <td><input type="text" name="tbheadercolor" size="12" value="$tbheadercolor"></td>
  </tr>
  <tr>
    <td><font face="Arial" size="2"><b>Table Main Colour:<br>
      </b></font><font face="Arial" size="1">The colour used for the main tables
      in locked.cgi.<br>
      i.e. the cells with forms in.</font></td>
    <td><input type="text" name="tbmaincolor" size="12" value="$tbmaincolor"></td>
  </tr>
  <tr>
    <td><font face="Arial" size="2"><b>Font Face:<br>
      </b></font><font face="Arial" size="1">The font face used for body text.</font></td>
    <td><input type="text" name="fontface" size="12" value="$fontface"></td>
  </tr>
  <tr>
    <td><font face="Arial" size="2"><b>Font Colour:<br>
      </b></font><font face="Arial" size="1">The font colour used for body text.</font></td>
    <td><input type="text" name="fontcolor" size="12" value="$fontcolor"></td>
  </tr>
  <tr>
    <td><font face="Arial" size="2"><b>Font Size:<br>
      </b></font><font face="Arial" size="1">The font size used for body text.</font></td>
    <td><input type="text" name="fontsize" size="12" value="$fontsize"></td>
  </tr>
  <tr>
    <td><font face="Arial" size="2"><b>Font Note Size:<br>
      </b></font><font face="Arial" size="1">The font size used to display small
      note text.&nbsp; Not used very much, it\'s best to set one size smaller
      than standard font size.</font></td>
    <td><input type="text" name="fontnotesize" size="12" value="$fontnotesize"></td>
  </tr>
  <tr>
    <td><font face="Arial" size="2"><b>Font Header Face:<br>
      </b></font><font face="Arial" size="1">The font face used for the text in
      the top header.</font></td>
    <td><input type="text" name="fontheaderface" size="12" value="$fontheaderface"></td>
  </tr>
  <tr>
    <td><font face="Arial" size="2"><b>Font Header Size:<br>
      </b></font><font face="Arial" size="1">The font face used for the text in
      the top header.</font></td>
    <td><input type="text" name="fontheadersize" size="12" value="$fontheadersize"></td>
  </tr>
  <tr>
    <td><font face="Arial" size="2"><b>Font Header Colour:<br>
      </b></font><font face="Arial" size="1">The font colour user for the text
      in the top header.</font></td>
    <td><input type="text" name="fontheadercolor" size="12" value="$fontheadercolor"></td>
  </tr>
  <tr>
    <td bgcolor="#000080" height="1"></td>
    <td bgcolor="#000080" height="1"></td>
  </tr>
  <tr>
    <td><font face="Arial" size="2"><b>Login.cgi Style/Version:<br>
      </b></font><font face="Arial" size="1">Which version of Locked Area Lite login.cgi do you wish to run, version 1 or 2.  If Version 1 fails or causes a the pop-up window to appear after entering correct login details, try Version 2.</font></td>
      ~;
if ($login_style eq "1"){
    print "<td><select name=\"login_style\"><option name=1 selected>Version 1</option><option name=2>Version 2</option></select></td>\n";
    } else {
    print "<td><select name=\"login_style\"><option name=1>Version 1</option><option name=2 selected>Version 2</option></select></td>\n";
}
	  print qq~
  </tr>
  <tr>
    <td bgcolor="#000080" height="1"></td>
    <td bgcolor="#000080" height="1"></td>
  </tr>  
  <tr>
    <td><font face="Arial" size="2"><b>Signup Status:<br>
      </b></font><font face="Arial" size="1">Do you want the registration form
      to be open to new registrations?&nbsp; Tick for online/yes.</font></td>
      ~;
if ($signup_status eq "Online"){
    print "<td><input type=\"checkbox\" name=\"signup_status\" value=\"Online\" checked></td>\n";
    } else {
    print "<td><input type=\"checkbox\" name=\"signup_status\" value=\"Online\"></td>\n";
}
	  print qq~
  </tr>
  <tr>
    <td bgcolor="#000080" height="1"></td>
    <td bgcolor="#000080" height="1"></td>
  </tr>
  <tr>
    <td>
      <p align="right"></td>
    <td><input type="submit" value="Update Config" name="Update"></td>
  </tr>
</table>
</form></font>
</td></tr>
<tr><td colspan=2><font face="Arial" size="1"><a href="admin.cgi?a=main&p=$enc_password">Main</a>
 : <a href="admin.cgi?a=list&p=$enc_password">List Users</a> : <a href="admin.cgi?a=add&p=$enc_password">Add User</a>
 : <a href="admin.cgi?a=remove&p=$enc_password">Delete Users</a> : <a href="admin.cgi?a=email&p=$enc_password">Bulk Email</a>
 : <a href="admin.cgi?a=config&p=$enc_password">Configuration</a> : <a href="admin.cgi?a=stats&p=$enc_password">Statistics</a>
 : <a href="http://$membersurl">My Member\'s Area</a></font></td></tr>
~;
&footer;

exit;
}

sub update_config {
$enc_password = $query->param(\'enc_password\');
$sitename = $query->param(\'sitename\');
$membersdb = $query->param(\'membersdb\');
$htpasswd = $query->param(\'htpasswd\');
$htaccess = $query->param(\'htaccess\');
$extra_field_name = $query->param(\'extra_field_name\');
$extra_url = $query->param(\'extra_url\');
$extra_required = $query->param(\'extra_required\');
$mailprog = $query->param(\'mailprog\');
$newmemberemail = $query->param(\'newmemberemail\');
$removemail = $query->param(\'removeemail\');
$adminname = $query->param(\'adminname\');
$adminmail = $query->param(\'adminmail\');
$adminpassword1 = $query->param(\'adminpassword\');
$imageurl = $query->param(\'imageurl\');
$cgiurl = $query->param(\'cgiurl\');
$membersurl = $query->param(\'membersurl\');
$tbheadercolor = $query->param(\'tbheadercolor\');
$tbmaincolor = $query->param(\'tbmaincolor\');
$fontface = $query->param(\'fontface\');
$fontcolor = $query->param(\'fontcolor\');
$fontsize = $query->param(\'fontsize\');
$fontnotesize = $query->param(\'fontnotesize\');
$fontheaderface = $query->param(\'fontheaderface\');
$fontheadersize = $query->param(\'fontheadersize\');
$fontheadercolor = $query->param(\'fontheadercolor\');
$terms = $query->param(\'terms\');
$show_records = $query->param(\'show_records\');
$signup_status = $query->param(\'signup_status\');
$login_style = $query->param(\'login_style\');

if ($adminpassword1 ne "") {
$adminpassword1 = crypt($adminpassword1, "La");
} else {
$adminpassword1 = $adminpassword;
}
if ($extra_url eq "") {
$extra_url = 0;
} else {
$extra_url = $extra_url;
}
if ($extra_required eq "") {
$extra_required = 0;
} else {
$extra_required = $extra_required;
}
if ($newmemberemail eq "") {
$newmemberemail = 0;
} else {
$newmemberemail = $newmemberemail;
}
if ($removemail eq "") {
$removemail = 0;
} else {
$removemail = $removemail;
}
if ($show_records eq "") {
$signup_status = 25;
}
if ($signup_status eq "") {
$signup_status = 0;
} else {
$signup_status = $signup_status;
}
if ($enc_password eq $adminpassword) {

open (CON, ">variables.pl") || warn "Locked Area Error: Cannot open variables.pl file: $!";
flock (CON, LOCK_EX) || warn "Locked Area Error: Cannot flock variables.pl.  $!";
print CON "# Variables.pl File.  Best not to touch this.\n";
print CON "\$sitename = \"$sitename\";\n";
print CON "\$membersdb = \"$membersdb\";\n";
print CON "\$htpasswd = \"$htpasswd\";\n";
print CON "\$htaccess = \"$htaccess\";\n";
print CON "\$extra_field_name = \"$extra_field_name\";\n";
print CON "\$extra_url = \"$extra_url\";\n";
print CON "\$extra_required = \"$extra_required\";\n";
print CON "\$mailprog = \"$mailprog\";\n";
print CON "\$newmemberemail = \"$newmemberemail\";\n";
print CON "\$removeemail = \"$removemail\";\n";
print CON "\$adminname = \"$adminname\";\n";
print CON "\$adminmail = \'$adminmail\';\n";
print CON "\$adminpassword = \"$adminpassword1\";\n";
print CON "\$imageurl = \"$imageurl\";\n";
print CON "\$cgiurl = \"$cgiurl\";\n";
print CON "\$membersurl = \"$membersurl\";\n";
print CON "\$tbheadercolor = \"$tbheadercolor\";\n";
print CON "\$tbmaincolor = \"$tbmaincolor\";\n";
print CON "\$fontface = \"$fontface\";\n";
print CON "\$fontcolor = \"$fontcolor\";\n";
print CON "\$fontsize = \"$fontsize\";\n";
print CON "\$fontnotesize = \"$fontnotesize\";\n";
print CON "\$fontheaderface = \"$fontheaderface\";\n";
print CON "\$fontheadersize = \"$fontheadersize\";\n";
print CON "\$fontheadercolor = \"$fontheadercolor\";\n";
print CON "\$terms = qq~\n$terms\n~;\n";
print CON "\$show_records = \"$show_records\";\n";
print CON "\$signup_status = \"$signup_status\";\n";
print CON "\$login_style = \"$login_style\";\n";
print CON "1;\n";
close (CON);
&header;
print qq~
<tr><td colspan=2>
<font face="Arial" size="2"><b><a href="admin.cgi?a=main&p=$enc_password">Top</a>: Configuration Updated</b><br>
Your configuration file has now been updated.
</td></tr>
<tr><td colspan=2><font face="Arial" size="1"><a href="admin.cgi?a=main&p=$enc_password">Main</a>
 : <a href="admin.cgi?a=list&p=$enc_password">List Users</a> : <a href="admin.cgi?a=add&p=$enc_password">Add User</a>
 : <a href="admin.cgi?a=remove&p=$enc_password">Delete Users</a> : <a href="admin.cgi?a=email&p=$enc_password">Bulk Email</a>
 : <a href="admin.cgi?a=config&p=$enc_password">Configuration</a> : <a href="admin.cgi?a=stats&p=$enc_password">Statistics</a>
 : <a href="http://$membersurl">My Member\'s Area</a></font></td></tr>
~;
&footer;
exit;
} else {
&admin_login_failed;
}
}

sub stats {
my $enc_password = param("p");
&call_stats;
&header;
print qq~
<tr><td colspan=2><font face="Arial" size="2">
<b><a href="admin.cgi?a=main&p=$enc_password">Top</a>: Statistics</b><br>
<ul><li><a href="admin.cgi?a=stats_s&p=$enc_password">Average Accesses Per Day</a><br>
<li><a href="admin.cgi?a=stats_l&p=$enc_password">Suspected Leachers</a><p>
<li><a href="admin.cgi?a=stats_b&p=$enc_password">Top Browsers</a><br>
<li><a href="admin.cgi?a=stats_u&p=$enc_password">Top Users</a><br>
<li><a href="admin.cgi?a=stats_r&p=$enc_password">Top Referrers</a><br>
<li><a href="admin.cgi?a=stats_i&p=$enc_password">Top IP Addresses</a><p>   
<li><a href="admin.cgi?a=stats_a&p=$enc_password">All Statistics</a><p>
</ul>
<b>Notice:</b><br>
If your statistics are blank it\'s because you\'re not calling logger.cgi from your member\'s area html using SSI tags!  Please read below:
<p><font face="Arial" size="2">logger.cgi is a simple little script that will display a Welcome [username] message when loaded into the member\'s
 area using SSI tags.&nbsp; It also records details about the visitor to a log file.&nbsp; This log file can be read here in the administration panel.<br>
 To call logger.cgi into your member\'s area html just place the following tag anywhere in your member\'s area html.</font></p>
<p align="center"><i><b><font face="Arial" size="2">&lt;!--#exec cgi=&quot;/cgi-bin/logger.cgi&quot;--&gt;</font></b></i></p>
</center>
<p align="left"><font face="Arial" size="2">If you didn\'t install the scripts into your cgi-bin, just modify the path.&nbsp; You must use a
 relative url.&nbsp; e.g. /dir/dir/logger.cgi or /cgi-bin/logger.cgi, not a full path or url.&nbsp; You may find that you need to use the extension .shtml
 to use SSI tags in your html.&nbsp; If you\'re not sure, contact your system administrator or have a look at your web host\'s FAQ page, most good
 hosts have them.</font></p>
</font></td></tr><tr><td colspan=2><font face="Arial" size="1"><a href="admin.cgi?a=main&p=$enc_password">Main</a>
 : <a href="admin.cgi?a=list&p=$enc_password">List Users</a> : <a href="admin.cgi?a=add&p=$enc_password">Add User</a>
 : <a href="admin.cgi?a=remove&p=$enc_password">Delete Users</a> : <a href="admin.cgi?a=email&p=$enc_password">Bulk Email</a>
 : <a href="admin.cgi?a=config&p=$enc_password">Configuration</a> : <a href="admin.cgi?a=stats&p=$enc_password">Statistics</a>
 : <a href="http://$membersurl">My Member\'s Area</a></font></td></tr>
~;
&footer;
exit;
}


sub stats_s {
my $enc_password = param("p");
&call_stats;
&header;
print "<tr><td colspan=2><center><table border=0 cellpadding=2 cellspaceing=0 width=400>\n";
print "<tr><td colspan=3><font face=Arial size=2><br><b>All Dates</b></td></tr>\n";
print "<tr><td><font face=Arial size=2>%</td><td><font face=Arial size=2>Qty</td><td><font face=Arial size=2>Date</td></tr>\n";
foreach $element (sort {$dates{$b} <=> $dates{$a}} keys %dates)
	{ $dpercent = sprintf("%2.1f",100*$dates{$element}/$numofrecs);
	  print "<tr><td><font face=Arial size=2>$dpercent\%</td><td><font face=Arial size=2>$dates{$element}</td><td><font face=Arial size=2>$element</td></tr>\n"; }

$avg = sprintf("%2.1f",$numofrecs/(scalar (keys %dates)));
print "<tr><td colspan=2><font face=Arial size=2><font face=Arial size=2>Average Number of Accesses per Day:</td><td><font face=Arial size=2>$avg</td></tr>\n";

print qq~
</table></center></td></tr><tr><td colspan=2><font face="Arial" size="1"><a href="admin.cgi?a=main&p=$enc_password">Main</a>
 : <a href="admin.cgi?a=list&p=$enc_password">List Users</a> : <a href="admin.cgi?a=add&p=$enc_password">Add User</a>
 : <a href="admin.cgi?a=remove&p=$enc_password">Delete Users</a> : <a href="admin.cgi?a=email&p=$enc_password">Bulk Email</a>
 : <a href="admin.cgi?a=config&p=$enc_password">Configuration</a> : <a href="admin.cgi?a=stats&p=$enc_password">Statistics</a>
 : <a href="http://$membersurl">My Member\'s Area</a></font></td></tr>
~;
&footer;
exit;
}

sub stats_l {
my $enc_password = param("p");
&call_stats;
&header;
print "<tr><td colspan=2><center><table border=0 cellpadding=2 cellspaceing=0 width=300>\n";
print "<tr><td colspan=2><font face=Arial size=2><font face=Arial size=2><b>Suspected Leechers</b></td></tr>\n";
print "<tr><td><font face=Arial size=2>Accesses</td><td><font face=Arial size=2>Username</td></tr>\n";

foreach $element (sort {$usernames{$b} <=> $usernames{$a}} keys %usernames) {
	if ($usernames{$element} > $leachnum) { print "<tr><td><font face=Arial size=2>$usernames{$element}</td><td><font face=Arial size=2>$element</td></tr>\n"; }
}
print qq~
</table></center></td></tr><tr><td colspan=2><font face="Arial" size="1"><a href="admin.cgi?a=main&p=$enc_password">Main</a>
 : <a href="admin.cgi?a=list&p=$enc_password">List Users</a> : <a href="admin.cgi?a=add&p=$enc_password">Add User</a>
 : <a href="admin.cgi?a=remove&p=$enc_password">Delete Users</a> : <a href="admin.cgi?a=email&p=$enc_password">Bulk Email</a>
 : <a href="admin.cgi?a=config&p=$enc_password">Configuration</a> : <a href="admin.cgi?a=stats&p=$enc_password">Statistics</a>
 : <a href="http://$membersurl">My Member\'s Area</a></font></td></tr>
~;
&footer;
exit;
}
sub stats_b {
my $enc_password = param("p");
&call_stats;
&header;
print "<tr><td colspan=2><center><table border=0 cellpadding=2 cellspaceing=0 width=460>\n";
$count = 0;
print "<tr><td colspan=4><font face=Arial size=2><br><b>Browsers</b></td></tr>\n";
print "<tr><td><font face=Arial size=2>Rank</td><td><font face=Arial size=2>%</td><td><font face=Arial size=2>Qty</td><td><font face=Arial size=2>Browser</td></tr>\n";
foreach $element (sort {$browsers{$b} <=> $browsers{$a}} keys %browsers) 
	{ $count++; break if ($count > 10);
	  $bpercent = sprintf("%2.1f",100*$browsers{$element}/$numofrecs);
	  print "<tr><td><font face=Arial size=2>$count</td><td><font face=Arial size=2>$bpercent\%</td><td><font face=Arial size=2>$browsers{$element}</td><td><font face=Arial size=2>$element</td></tr>\n"; }

print qq~
</table></center></td></tr><tr><td colspan=2><font face="Arial" size="1"><a href="admin.cgi?a=main&p=$enc_password">Main</a>
 : <a href="admin.cgi?a=list&p=$enc_password">List Users</a> : <a href="admin.cgi?a=add&p=$enc_password">Add User</a>
 : <a href="admin.cgi?a=remove&p=$enc_password">Delete Users</a> : <a href="admin.cgi?a=email&p=$enc_password">Bulk Email</a>
 : <a href="admin.cgi?a=config&p=$enc_password">Configuration</a> : <a href="admin.cgi?a=stats&p=$enc_password">Statistics</a>
 : <a href="http://$membersurl">My Member\'s Area</a></font></td></tr>
~;
&footer;
exit;
}
sub stats_u {
my $enc_password = param("p");
&call_stats;
&header;
print "<tr><td colspan=2><center><table border=0 cellpadding=2 cellspaceing=0 width=400>\n";
$count = 0;
print "<tr><td colspan=4><font face=Arial size=2><b>Users</b></td></tr>\n";
print "<tr><td><font face=Arial size=2>Rank</td><td><font face=Arial size=2>%</td><td><font face=Arial size=2>Qty</td><td><font face=Arial size=2>Username</td></tr>\n";
foreach $element (sort {$usernames{$b} <=> $usernames{$a}} keys %usernames) 
	{ $count++; break if ($count > 10);
	  $upercent = sprintf("%2.1f",100*$usernames{$element}/$numofrecs);
	  print "<tr><td><font face=Arial size=2>$count</td><td><font face=Arial size=2>$upercent\%</td><td><font face=Arial size=2>$usernames{$element}</td><td><font face=Arial size=2>$element<br></td></tr>\n"; }
print qq~
</table></center></td></tr><tr><td colspan=2><font face="Arial" size="1"><a href="admin.cgi?a=main&p=$enc_password">Main</a>
 : <a href="admin.cgi?a=list&p=$enc_password">List Users</a> : <a href="admin.cgi?a=add&p=$enc_password">Add User</a>
 : <a href="admin.cgi?a=remove&p=$enc_password">Delete Users</a> : <a href="admin.cgi?a=email&p=$enc_password">Bulk Email</a>
 : <a href="admin.cgi?a=config&p=$enc_password">Configuration</a> : <a href="admin.cgi?a=stats&p=$enc_password">Statistics</a>
 : <a href="http://$membersurl">My Member\'s Area</a></font></td></tr>
~;
&footer;
exit;
}
sub stats_a {
my $enc_password = param("p");
&call_stats;
&header;
print "<tr><td colspan=2><font face=Arial size=1>This features lists all the ips, browsers etc that have been logged.  It may take a while to load!!</font>\n";
print "<center><table border=0 cellpadding=2 cellspaceing=0 width=460>\n";
print "<tr><td colspan=3><font face=Arial size=2><b>All Users</b></td></tr>\n";
print "<tr><td><font face=Arial size=2>%</td><td><font face=Arial size=2>Qty</td><td><font face=Arial size=2>Username</td></tr>\n";
foreach $element (sort {$usernames{$b} <=> $usernames{$a}} keys %usernames) 
	{ $upercent = sprintf("%2.1f",100*$usernames{$element}/$numofrecs);
	  print "<tr><td><font face=Arial size=2>$upercent\%</td><td><font face=Arial size=2>$usernames{$element}</td><td><font face=Arial size=2>$element<br></td></tr>\n"; }
print "</table></center>";
print "<center><table border=0 cellpadding=2 cellspaceing=0 width=460>\n";
print "<tr><td colspan=3><font face=Arial size=2><br><b>All IP Addresses</b></td></tr>\n";
print "<tr><td><font face=Arial size=2>%</td><td><font face=Arial size=2>Qty</td><td><font face=Arial size=2>IP</td></tr>\n";
foreach $element (sort {$ips{$b} <=> $ips{$a}} keys %ips) 
	{ $ipercent = sprintf("%2.1f",100*$ips{$element}/$numofrecs);
	  print "<tr><td><font face=Arial size=2>$ipercent\%</td><td><font face=Arial size=2>$ips{$element}</td><td><font face=Arial size=2>$element</td></tr>\n"; }
print "</table></center>";
print "<center><table border=0 cellpadding=2 cellspaceing=0 width=460>\n";
print "<tr><td colspan=3><font face=Arial size=2><br><b>All Referrers</b></td></tr>\n";
print "<tr><td><font face=Arial size=2>%</td><td><font face=Arial size=2>Qty</td><td><font face=Arial size=2>URL</td></tr>\n";
foreach $element (sort {$referrers{$b} <=> $referrers{$a}} keys %referrers) 
	{ $rpercent = sprintf("%2.1f",100*$referrers{$element}/$numofrecs);
	  print "<tr><td><font face=Arial size=2>$rpercent\%</td><td><font face=Arial size=2>$referrers{$element}</td><td><font face=Arial size=2>$element</td></tr>\n"; }
print "</table></center>";
print "<center><table border=0 cellpadding=2 cellspaceing=0 width=460>\n";
print "<tr><td colspan=3><font face=Arial size=2><br><b>All Browsers</b></td></tr>\n";
print "<tr><td><font face=Arial size=2>%</td><td><font face=Arial size=2>Qty</td><td><font face=Arial size=2>Browser</td></tr>\n";
foreach $element (sort {$browsers{$b} <=> $browsers{$a}} keys %browsers) 
	{ $bpercent = sprintf("%2.1f",100*$browsers{$element}/$numofrecs);
	  print "<tr><td><font face=Arial size=2>$bpercent\%</td><td><font face=Arial size=2>$browsers{$element}</td><td><font face=Arial size=2>$element</td></tr>\n"; }

print qq~
</table></center></td></tr><tr><td colspan=2><font face="Arial" size="1"><a href="admin.cgi?a=main&p=$enc_password">Main</a>
 : <a href="admin.cgi?a=list&p=$enc_password">List Users</a> : <a href="admin.cgi?a=add&p=$enc_password">Add User</a>
 : <a href="admin.cgi?a=remove&p=$enc_password">Delete Users</a> : <a href="admin.cgi?a=email&p=$enc_password">Bulk Email</a>
 : <a href="admin.cgi?a=config&p=$enc_password">Configuration</a> : <a href="admin.cgi?a=stats&p=$enc_password">Statistics</a>
 : <a href="http://$membersurl">My Member\'s Area</a></font></td></tr>
~;
&footer;
exit;
}
sub stats_r {
my $enc_password = param("p");
&call_stats;
&header;
print "<tr><td colspan=2><center><table border=0 cellpadding=2 cellspaceing=0 width=460>\n";
$count = 0;
print "<tr><td colspan=4><font face=Arial size=2><br><b>Referrers</b></td></tr>\n";
print "<tr><td><font face=Arial size=2>Rank</td><td><font face=Arial size=2>%</td><td><font face=Arial size=2>Qty</td><td><font face=Arial size=2>URL</td></tr>\n";
foreach $element (sort {$referrers{$b} <=> $referrers{$a}} keys %referrers) 
	{ $count++; break if ($count > 10);
	  $rpercent = sprintf("%2.1f",100*$referrers{$element}/$numofrecs);
	  print "<tr><td><font face=Arial size=2>$count</td><td><font face=Arial size=2>$rpercent\%</td><td><font face=Arial size=2>$referrers{$element}</td><td><font face=Arial size=2><a href=$element>$element</a></td></tr>\n"; }
print qq~
</table></center></td></tr><tr><td colspan=2><font face="Arial" size="1"><a href="admin.cgi?a=main&p=$enc_password">Main</a>
 : <a href="admin.cgi?a=list&p=$enc_password">List Users</a> : <a href="admin.cgi?a=add&p=$enc_password">Add User</a>
 : <a href="admin.cgi?a=remove&p=$enc_password">Delete Users</a> : <a href="admin.cgi?a=email&p=$enc_password">Bulk Email</a>
 : <a href="admin.cgi?a=config&p=$enc_password">Configuration</a> : <a href="admin.cgi?a=stats&p=$enc_password">Statistics</a>
 : <a href="http://$membersurl">My Member\'s Area</a></font></td></tr>
~;
&footer;
exit;
}
sub stats_i {
my $enc_password = param("p");
&call_stats;
&header;
print "<tr><td colspan=2><center><table border=0 cellpadding=2 cellspaceing=0 width=400>\n";
$count = 0;
print "<tr><td colspan=4><font face=Arial size=2><br><b>IP Addresses</b></td></tr>\n";
print "<tr><td><font face=Arial size=2>Rank</td><td><font face=Arial size=2>%</td><td><font face=Arial size=2>Qty</td><td><font face=Arial size=2>IP</td></tr>\n";
foreach $element (sort {$ips{$b} <=> $ips{$a}} keys %ips) 
	{ $count++; break if ($count > 10);
	  $ipercent = sprintf("%2.1f",100*$ips{$element}/$numofrecs);
	  print "<tr><td><font face=Arial size=2>$count</td><td><font face=Arial size=2>$ipercent\%</td><td><font face=Arial size=2>$ips{$element}</td><td><font face=Arial size=2>$element</td></tr>\n"; }
print qq~
</table></center></td></tr><tr><td colspan=2><font face="Arial" size="1"><a href="admin.cgi?a=main&p=$enc_password">Main</a>
 : <a href="admin.cgi?a=list&p=$enc_password">List Users</a> : <a href="admin.cgi?a=add&p=$enc_password">Add User</a>
 : <a href="admin.cgi?a=remove&p=$enc_password">Delete Users</a> : <a href="admin.cgi?a=email&p=$enc_password">Bulk Email</a>
 : <a href="admin.cgi?a=config&p=$enc_password">Configuration</a> : <a href="admin.cgi?a=stats&p=$enc_password">Statistics</a>
 : <a href="http://$membersurl">My Member\'s Area</a></font></td></tr>
~;
&footer;
exit;
}

sub admin_main {
$admin_password = $query->param(\'admin_password\');
$enc_password = crypt($admin_password, "La");
if ($enc_password eq $adminpassword) {
print qq~
<!-- Generated by Locked Area Lite v3.2 Linux Stable -->
<html><head><title>Locked Area Lite v3.2 Linux Stable Administration Panel</title>
<META HTTP-EQUIV=Refresh CONTENT=\'0;URL=admin.cgi?a=main&amp;p=$enc_password\'></head>
<body topmargin="0" leftmargin="0" bgcolor="#DDDDDD" text="#000000" link="#000080" vlink="#800000" alink="#800000">
<font face="Arial" size="2">Please wait while we redirect you to the admininistration panel.<br>
If you are not redirected in the next 5 seconds, please <a href="admin.cgi?a=main&amp;p=$enc_password">click here</a>.
</body></html>
~;
} else {
&admin_login_failed;
}
}

sub admin_main2 {
my $enc_password = param("p");
$uptime = `uptime`;
&count_users;
&header;
print qq~
<tr><td align=right colspan=2>
<table border="0" cellspacing="0" width="500">
<tr><td colspan="2" valign="top"><font face="Arial" size="2">Welcome to the Locked Area Lite v3.2 Linux Stable Administration Panel.&nbsp; From here you can manage your member\'s area and it\'s member\'s.&nbsp; To begin please select a link from the left select menu.</font></td>
</tr><tr><td width="380" valign="top">
<table border="0" cellspacing="0" width="370" cellpadding="2">
<tr><td colspan="2" width="364"><b><font face="Arial" size="2">Member\'s Area Information</font></b></td></tr>
<tr><td width="140"><font face="Arial" size="2">Current Member\'s:</font></td><td width="218"><font face="Arial" size="2">$user_count</font></td></tr>
<tr><td width="140"><font face="Arial" size="2">Signup Form Status:</font></td><td width="218"><font face="Arial" size="2">$signup_status</font></td></tr>
<tr><td colspan="2" width="364"><font face="Arial" size="2"><br><b>Locked Area Lite Details</b></font></td></tr>
<tr><td width="140"><font face="Arial" size="2">Version No.</font></td><td width="218"><font face="Arial" size="2">3.2 Linux Stable</font></td></tr>
<tr><td width="140"><font face="Arial" size="2">Latest Version:</font></td><td width="218"><font face="Arial" size="2"><img src="http://www.locked-area.com/version/latest.gif" width="27" height="14"></font></td></tr>
<tr><td width="358" colspan="2"><font face="Arial" size="2"><br><b>Rate Locked Area Lite</b></font></td></tr>
<tr><td width="358" colspan="2"><table border="0" cellspacing="0" width="100%">
<tr><td width="50%" valign="top" align="center"><table border="0" cellpadding="0" cellspacing="0">
<tr><td align=center><b><font face="Arial" size="2">HotScripts.com</font></b></tr><tr><td><form action="http://www.hotscripts.com/cgi-bin/rate.cgi" method="POST">
<input type="hidden" name="ID" value="4006"><b><div align="center"><center><font face="Arial" size="2">
<select name="ex_rate" size="1"><option value="5" selected>Excellent!</option><option value="4">Very Good</option><option value="3">Good</option>
<option value="2">Fair</option><option value="1">Poor</option></select><input type="submit" value="Rate It"></font>
</center></div></form></b></td></tr></table></td>
<td width="50%" valign="top" align="center"><table border="0" cellpadding="0" cellspacing="0">
<tr><td align=center><b><font face="Arial" size="2">The CGI Resource Index</font></b></tr>
<tr><td><form method="POST" action="http://cgi-resources.com/rate/index.cgi">
<input type="hidden" name="referer" value="http://cgi-resources.com/">
<input type="hidden" name="link_code" value="04463">
<input type="hidden" name="category_name" value="Programs and Scripts/Perl/Password Protection/">
<input type="hidden" name="link_name" value="Locked Area"><b><div align="center"><center>
</b><font face="Arial" size="2"><select name="rating" size="1">
<option selected>-- </option><option>10 </option><option>9 </option><option>8 </option><option>7 </option><option>6 </option>
<option>5 </option><option>4 </option><option>3 </option><option>2 </option><option>1 </option></select> <input type="submit" value="Rate It"><br>
10 - Great / 0 - Poor</font></center></div></form></td></tr></table></td></tr></table>
</td></tr></table></td>
<td width="120" valign="top"><font face="Arial" size="2"><b>Select Menu<br>
</b><a href="admin.cgi?a=main&p=$enc_password">Main</a><br>
<a href="admin.cgi?a=list&p=$enc_password">List Users</a><br>
<a href="admin.cgi?a=add&p=$enc_password">Add New User</a><br>
<a href="admin.cgi?a=remove&p=$enc_password">Delete Users</a><br>
<a href="admin.cgi?a=email&p=$enc_password">Bulk Email</a><br>
<a href="admin.cgi?a=stats&p=$enc_password">Statistics</a></font>
<p><font face="Arial" size="2"><a href="admin.cgi?a=config&p=$enc_password">Configuration</a><br>
<a href="http://$membersurl">My Member\'s Area</a></font></p>
<p><font face="Arial" size="2"><b>LockedArea.com<br>
</b><a href="http://www.locked-area.com/html/members/">Member\'s Area</a><br>
<a href="http://www.locked-area.com/html/members/forum/">Support Forum</a><br>
<a href="http://www.locked-area.com/html/members/addons/">Add-Ons</a></font></td>
</tr></table></td></tr>
<tr><td colspan=2><font face="Arial" size="1"><a href="admin.cgi?a=main&p=$enc_password">Main</a>
 : <a href="admin.cgi?a=list&p=$enc_password">List Users</a> : <a href="admin.cgi?a=add&p=$enc_password">Add User</a>
 : <a href="admin.cgi?a=remove&p=$enc_password">Delete Users</a> : <a href="admin.cgi?a=email&p=$enc_password">Bulk Email</a>
 : <a href="admin.cgi?a=config&p=$enc_password">Configuration</a> : <a href="admin.cgi?a=stats&p=$enc_password">Statistics</a>
 : <a href="http://$membersurl">My Member\'s Area</a></font></td></tr>
~;
&footer;
exit;
}

sub print_login {

print qq~
<!-- Generated by Locked Area Lite v3.2 Linux Stable -->
<html><head><title>Locked Area Lite v3.2 Administration Panel</title></head>
<body topmargin="0" leftmargin="0" bgcolor="#DDDDDD" text="#000000" link="#000080" vlink="#800000" alink="#800000">
<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
<tr><td width="100%" align=center valign=middle>
<form method="POST" action="admin.cgi"><input type="hidden" name="admin_main" value="yes">
<table border="0" cellspacing="0" width="400" cellpadding="2">
<tr><td colspan="2"><font face="Arial" size="2"><b>Locked Area Lite v3.2 Linux Stable<br>
</b>To login to the Locked Area Lite v3.2 Administration Panel, please enter your password below and click login.  Please note, all failed attempts are logged.<br>
&nbsp;</font></td></tr><tr><td>
<p align="right"><font face="Arial" size="2">Password: </font><input type="password" name="admin_password" size="20"></td>
<td><p align="left"><input type="submit" value="Login" name="admin_login"></td>
</tr></table></form><table border="0" cellspacing="0" width="400" cellpadding="2"><tr><td align=right colspan=2>
<font size="1" face="Arial">Powered by <a href="http://www.locked-area.com/html/">Locked Area Lite</a> v3.2 Linux Stable, a product of <a href="http://www.lockedarea.com/">LockedArea.com</a>.<br>
Copyright &copy; 1999 - 2003 Neil Skirrow and LockedArea.com, All Rights Reserved.</font></td></tr></table><p>&nbsp;</p><p>&nbsp;</p>
</td></tr></table></body></html>
~;
exit;
}

sub admin_login_failed {
$password = $query->param(\'admin_password\');
$time = localtime(time);
$ip = $ENV{\'REMOTE_ADDR\'};
$ref = $ENV{\'HTTP_REFERER\'};
$browser = $ENV{\'HTTP_USER_AGENT\'};

open (DATABASE, ">>failed_logins.log") || warn "Locked Area Error: Cannot open failed logins log file: $!";
flock (DATABASE, LOCK_EX) || warn "Locked Area Error: Cannot flock failed logins log.  $!";
print DATABASE "$ip|$ref|$browser|$password|$time\n";
close (DATABASE);


print qq~
<!-- Generated by Locked Area Lite v3.2 Linux Stable -->
<html><head><title>Locked Area Lite v3.2 Administration Panel</title></head>
<body topmargin="0" leftmargin="0" bgcolor="#DDDDDD" text="#000000" link="#000080" vlink="#800000" alink="#800000">
<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
<tr><td width="100%" align=center valign=middle>
<form method="POST" action="admin.cgi"><input type="hidden" name="admin_main" value="yes">
<table border="0" cellspacing="0" width="400" cellpadding="2">
<tr><td colspan="2"><font face="Arial" size="2"><b>Locked Area Lite v3.2 Linux Stable<br>
</b>The password you tried to login with was incorrect, please feel free to try again but note, all failed attempts are logged as was this failed attempt.<br>
&nbsp; </font></td></tr><tr><td>
<p align="right"><font face="Arial" size="2">Password: </font><input type="password" name="admin_password" size="20"></td>
<td><p align="left"><input type="submit" value="Login" name="admin_login"></td>
</tr></table></form>
<table border="0" cellspacing="0" width="400" cellpadding="2"><tr><td align=right colspan=2>
<font size="1" face="Arial">Powered by <a href="http://www.locked-area.com/html/">Locked Area Lite</a> v3.2 Linux Stable, a product of <a href="http://www.lockedarea.com/">LockedArea.com</a>.<br>
Copyright &copy; 1999 - 2003 Neil Skirrow and LockedArea.com, All Rights Reserved.</font></td></tr></table><p>&nbsp;</p><p>&nbsp;</p>
</td></tr></table>
</body></html>
~;
exit;
}

sub call_stats {
if (-e "userlog.txt") {
open(FILE, "userlog.txt") || warn "Locked Area Error Can\'t open user log: $!";
@buffer = <FILE>;
close(FILE);

$numofrecs = 0;
foreach $element (@buffer) {
	$numofrecs++;
	($u,$i,$r,$b,$d) = split(/\|/, $element);
	($x,$m,$w,$t,$y) = split(/\ /, $d);
	$usernames{$u}++;
	$ips{$i}++;
	$referrers{$r}++;
	$browsers{$b}++;
	$dates{$w."-".$m."-".$y}++;
}
} else {
&header;
print "<tr><td colspan=2><font face=Arial size=2>Unable to read userlog.txt file.</font></td></tr>\n";
&footer;
exit;
}
}

sub count_users {
$user_count="0";
open (UC, "$membersdb") || warn "Locked Area Error: Cannot open database file: $!";
@uc =<UC>;
close (UC);
foreach $uc (@uc) { $user_count++; }
}

# Generates random salt.
sub salt {
   my ($maxlen) = $_[0] || 2;
   my (@vowel) = (qw (a a 2 e e e 3 i i i o o o u u 6 ai au ay ea
                      ee eu ia ie io oa oi oo oy));
   my (@consonant) = (qw (b c d f 2 h j k l m 6 p qu 8 s t v w x 9 th st
                          sh ph ng nd));
   my ($salt) = "";
   srand;                 
   my ($vowelnext) = int(rand(2));  # Initialise to 0 or 1 (ie true or false)
   do { if ($vowelnext) { $salt .= $vowel[rand(@vowel)]; } else { $salt .= $consonant[rand(@consonant)]; }
   $vowelnext = !$vowelnext; } 
   until length($salt) >= $maxlen;
   return $salt;
}

# Generates the date for database use specifically.
sub get_date {
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
	@months = ("01","02","03","04","05","06","07","08","09","10","11","12");
	@digits = split(//,$sec);
	$size = @digits;
	if ($size == 1) {
		$sec = "0$sec";
	}
	@digits = split(//,$min);
	$size = @digits;
	if ($size == 1) {
		$min = "0$min";
	}
	$year=$year+1900;
	@digits = split(//,$mday);
	$size = @digits;
	if ($size == 1) {
		$mday = "0$mday";
	}
	
	$date = "@months[$mon]/$mday/$year";
}


sub header {
# Please do not remove the below.  It causes no harm to you.
print qq~
<!-- Generated by Locked Area Lite v3.2 Linux Stable -->
<html><head><title>Locked Area Lite v3.2 Linux Stable Administration Panel</title></head>
<body topmargin="0" leftmargin="0" bgcolor="#DDDDDD" text="#000000" link="#000080" vlink="#800000" alink="#800000">
<center>&nbsp;<br><table width=500 cellpadding=0 cellspacing=0 border=0>
<tr><td width=300><a href="http://www.locked-area.com/"><img src="$imageurl/top.gif" alt="Locked Area Lite v3.2 Linux Stable" border=0 width=280 height=45></a></td>
<td align=right><a href="http://www.linux.org/"><img src="$imageurl/linux.gif" alt="Locked Area Lite for Linux" border=0 width=29 height=41></a></td>
</tr><tr><td colspan=2 height=2 bgcolor="#7A7A7A"><img src="$imageurl/space.gif" width=100 height=2></td></tr>

~;
}

sub footer {
# The below copyright notice may not be modified in anyway!  It is too remain at all times and be visible in all HTML generated by Locked Area Lite.
print qq~
<tr><td align=right colspan=2>
<font size="1" face="Arial"><br>Powered by <a href="http://www.locked-area.com/html/">Locked Area Lite</a> v3.2 Linux Stable, a product of <a href="http://www.lockedarea.com/">LockedArea.com</a>.<br>
Copyright &copy; 1999 - 2003 Neil Skirrow and LockedArea.com, All Rights Reserved.</font></td></tr></table><p>&nbsp;</p><p>&nbsp;</p>
</td></tr></table>
</body></html>
~;
# The above copyright notice may not be modified in anyway!  It is too remain at all times and be visible in all HTML generated by Locked Area Lite.
# Removing the copyright note, text and link back is a criminal offence and a breech of the contract you have with LockedArea.com.  Doing so will result in legal action!
}';
close(ADMIN);

open(LOCKED, ">$cgiscriptdir/locked.cgi") || &die_clean("Locked Area Error: Cannot open/create locked.cgi file: $!\n");
flock (LOCKED, LOCK_EX) || &die_clean("Locked Area Error: Cannot flock locked.cgi file.  $!\n");
print LOCKED "$pathperl\n";
print LOCKED '#######################################################
# Locked Area Lite Version 3.2 Linux Stable
#                  http://www.lockedarea.com/
# Originally Released:     1st September 1999 (v1.0)
# Latest Release:          29th September 2003 (v3.2)
#######################################################
#
# COPYRIGHT NOTE:
# Locked Area Lite may be used and modified by anyone so
# long as they have a fully registered copy and this 
# copyright notice and the comments above remain intact.
# By using this code you agree to indemnify Neil Skirrow 
# and LockedArea.com from any liability that might arise
# from its use. Selling the code for this program without 
# prior written consent is expressly forbidden. In other
# words, please ask first before you try and make money
# off of our program. Obtain permission before 
# redistributing this software over the Internet or in 
# any other medium. In all cases copyright and header 
# must remain intact.  We cannot be held responsible 
# for any harm this may cause. 
#
#######################################################
use CGI qw(:standard); 	# Calls CGI.pm Library
$query = new CGI;
use Fcntl qw(:flock);  	# Calls File Locking Library
#######################################################
# The above three lines are essential to the script, if
# they are causing you an error, you don\'t have the
# required modules to use Locked Area Lite v3.2 Linux.
# Contact your web host and ask them to install them as
# they are essential modules.
#######################################################
# THIS FILE REQUIRES NO MANUAL MODIFICATION TO BE USED
# WITH THE EXCEPTION OF THE PATH TO PERL ON THE TOP 
# LINE OTHERWISE ALL CONFIGURATION IS DONE FROM THE 
# ADMIN PANEL.
#######################################################
require "variables.pl";	# Go and get the variables.
print "Content-type: text/html\n\n";
&print_edit if ($ENV{\'QUERY_STRING\'} eq "passwd");
&print_edit if ($ENV{\'QUERY_STRING\'} eq "edit");
&print_delete if ($ENV{\'QUERY_STRING\'} eq "delete");
&print_findpass if ($ENV{\'QUERY_STRING\'} eq "find");
$go_delete = $query->param(\'go_delete\');
&go_delete if ($go_delete && $ENV{\'REQUEST_METHOD\'} eq "POST");
$go_edit = $query->param(\'go_edit\');
&go_edit if ($go_edit && $ENV{\'REQUEST_METHOD\'} eq "POST");
$go_acctedit = $query->param(\'go_acctedit\');
&go_acctedit if ($go_acctedit && $ENV{\'REQUEST_METHOD\'} eq "POST");
$go_pass = $query->param(\'go_pass\');
&go_pass if ($go_pass && $ENV{\'REQUEST_METHOD\'} eq "POST");
&print_form if ($ENV{\'REQUEST_METHOD\'} eq "GET");
&user_join if ($ENV{\'REQUEST_METHOD\'} eq "POST");
$membersdb = $membersdb;
# First thing you see when loading locked.cgi.  Main registration form.
sub print_form {
if ($signup_status eq "Online") {
&get_date;
&header;
print qq~
<!-- Form Code -->
<form action="locked.cgi" method="post"><table width=400 cellpadding=2 cellspacing=0 border=0 bgcolor=$tbmaincolor>
<tr><td colspan=2 bgcolor=$tbheadercolor><font face=$fontheaderface size=$fontheadersize color=$fontheadercolor>$sitename: Account Signup Form</font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor>Please enter your details below, you will be emailed your login details immediately.</font></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>Full Name</font></td><td bgcolor=$tbmaincolor><input type=text name=name size=25></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>Email Address.</font></td><td bgcolor=$tbmaincolor><input type=text name=email1 size=25></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>Desired Username.</font></td><td bgcolor=$tbmaincolor><input type=text name=username size=25></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>Desired Password.</font></td><td bgcolor=$tbmaincolor><input type=password name=password size=25></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>Confirm Password.</font></td><td bgcolor=$tbmaincolor><input type=password name=password2 size=25></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>$extra_field_name.</font></td><td bgcolor=$tbmaincolor><input type=text name=extra size=25></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor>$terms<br><center><table border="0" cellpadding="0" cellspacing="0 width="280">
<tr><td width="280" bgcolor="Navy" height="1" colspan=2><img src="$imagesrc/space.gif" width=1 height=1></td></tr><tr><td width="260"><small><font face="Arial">I agree to the above terms and conditions --&gt;</font></small></td><td width="20"><input type="checkbox" name="agree" value="agree"></td></tr></table></center></font></td></tr>
<tr><td bgcolor=$tbmaincolor align=right><br><input type=reset value=Reset></td><td bgcolor=$tbmaincolor align=center><br><input type=submit value=Submit></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor align=center><font face=$fontface size=$fontnotesize color=$fontcolor><a href="locked.cgi?edit">Edit Account Information</a> : <a href="locked.cgi?find">Request New Password</a> : <a href="locked.cgi?delete">Cancel Membership</a></font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor align=right><font face=$fontface size=$fontnotesize color=$fontcolor><br>$date</font></td></tr>
</table></form>
~;
&footer;
} else {
# Displays if registration form is closed.  $signup_status not set to Online.
&get_date;
&header;
print qq~
<table width=400 cellpadding=2 cellspacing=0 border=0 bgcolor=$tbmaincolor>
<tr><td colspan=2 bgcolor=$tbheadercolor><font face=$fontheaderface size=$fontheadersize color=$fontheadercolor>$sitename: Account Signup Form</font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=#FF0000>I\'m afraid we\'re currently not accepting any new signups, please come back later.<p>
<b>Locked Area Note</b><br>
This is appearing because you have set the signup status to offline.  To change this please login to the Locked Area Lite v3.2 administration panel, then select the Configuration section.  Now, scroll to the bottom and tick the signup status tick box, then click Update.  Your registration form should now be accessible.</font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor align=center><font face=$fontface size=$fontnotesize color=$fontcolor><a href="locked.cgi?edit">Edit Account Information</a> : <a href="locked.cgi?find">Request New Password</a> : <a href="locked.cgi?delete">Cancel Membership</a></font></td></tr>
</table>
~;
&footer;
}

}

# User tries to register.	
sub user_join {
if ($signup_status eq "Online") {
$username = $query->param(\'username\');
$password = $query->param(\'password\');
$password2 = $query->param(\'password2\');
$email1 = $query->param(\'email1\');
$name = $query->param(\'name\');
$extra1 = $query->param(\'extra\');
$agree = $query->param(\'agree\');

$password1 = $password;

$usernameok = $username if (length($username) > 6);
$passwordok = $password if (($password eq $password2) && (length($password) > 6));
$emailok = $email1;

if ($extra_url eq "1") {
$extra = $extra1 if (substr($extra1,0,7) eq \'http://\'); # URL validation check if wanted.
} else { $extra = $extra1 }

# This checks all fields have been filled in.
if ($extra_required eq "1") {
unless ($usernameok && $passwordok && $emailok && $name && $extra && $agree) {
&header;
print qq~
<form action="locked.cgi" method="post"><input type="hidden" name="validationcode" value="$validationcode"><table width=400 cellpadding=2 cellspacing=0 border=0 bgcolor=$tbmaincolor>
<tr><td colspan=2 bgcolor=$tbheadercolor><font face=$fontheaderface size=$fontheadersize color=$fontheadercolor>$sitename: Account Signup Form Error</font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor>Sorry, but we found some problems with your submission.  Please make the following corrections:</font><br>
<font face=$fontface size=$fontsize color=#FF0000><ul>
~;
	print "<li>Either you didn\'t enter a username or it was less than 6 characters in length.<br>" unless ($usernameok);
	print "" unless ($usernameok && $emailok);
	print "<li>Either you didn\'t enter a password or it was less than 6 characters in length.<br>" unless ($passwordok);
	print "" unless ($usernameok && $emailok);
	print "<li>Either you didn\'t enter a email address or the email address you entered didn\'t match your confirm email address<br>" unless ($emailok);
	print "" unless ($emailok && $agree);
	print "<li>You did not enter your full name.<br>" unless ($name);
	print "" unless ($emailok && $agree);
	print "<li>You did not enter your $extra_field_name.<br>" unless ($extra);
	print "" unless ($emailok && $agree);
	print "<li>You did not agree to the terms and conditions.<br>" unless ($agree);
	print qq~
</ul></font></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>Full Name</font></td><td bgcolor=$tbmaincolor><input type=text name=name size=25 value="$name"></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>Email Address.</font></td><td bgcolor=$tbmaincolor><input type=text name=email1 size=25 value="$email1"></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>Desired Username.</font></td><td bgcolor=$tbmaincolor><input type=text name=username size=25 value="$username"></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>Desired Password.</font></td><td bgcolor=$tbmaincolor><input type=password name=password size=25 value="$password"></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>Confirm Password.</font></td><td bgcolor=$tbmaincolor><input type=password name=password2 size=25 value="$password2"></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>$extra_field_name.</font></td><td bgcolor=$tbmaincolor><input type=text name=extra size=25 value="$extra1"></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor>$terms<br><center><table border="0" cellpadding="0" cellspacing="0 width="280">
<tr><td width="280" bgcolor="Navy" height="1" colspan=2><img src="$imagesrc/space.gif" width=1 height=1></td></tr><tr><td width="260"><small><font face="Arial">I agree to the above terms and conditions --&gt;</font></small></td><td width="20"><input type="checkbox" name="agree" value="agree"></td></tr></table></center></font></td></tr>
<tr><td bgcolor=$tbmaincolor align=right><br><input type=reset value=Reset></td><td bgcolor=$tbmaincolor align=center><br><input type=submit value=Submit></td></tr>
</table></form>
~;
&footer;
	exit;
}
} else {
unless ($usernameok && $passwordok && $emailok && $name && $agree) {
&header;
print qq~
<form action="locked.cgi" method="post"><input type="hidden" name="validationcode" value="$validationcode"><table width=400 cellpadding=2 cellspacing=0 border=0 bgcolor=$tbmaincolor>
<tr><td colspan=2 bgcolor=$tbheadercolor><font face=$fontheaderface size=$fontheadersize color=$fontheadercolor>$sitename: Account Signup Form Error</font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor>Sorry, but we found some problems with your submission.  Please make the following corrections:</font><br>
<font face=$fontface size=$fontsize color=#FF0000><ul>
~;
	print "<li>Either you didn\'t enter a username or it was less than 6 characters in length.<br>" unless ($usernameok);
	print "" unless ($usernameok && $emailok);
	print "<li>Either you didn\'t enter a password or it was less than 6 characters in length.<br>" unless ($passwordok);
	print "" unless ($usernameok && $emailok);
	print "<li>Either you didn\'t enter a email address or the email address you entered didn\'t match your confirm email address<br>" unless ($emailok);
	print "" unless ($emailok && $agree);
	print "<li>You did not enter your full name.<br>" unless ($name);
	print "" unless ($emailok && $agree);
	print "<li>You did not agree to the terms and conditions.<br>" unless ($agree);
	print qq~
</ul></font></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>Full Name</font></td><td bgcolor=$tbmaincolor><input type=text name=name size=25 value="$name"></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>Email Address.</font></td><td bgcolor=$tbmaincolor><input type=text name=email1 size=25 value="$email1"></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>Desired Username.</font></td><td bgcolor=$tbmaincolor><input type=text name=username size=25 value="$username"></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>Desired Password.</font></td><td bgcolor=$tbmaincolor><input type=password name=password size=25 value="$password"></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>Confirm Password.</font></td><td bgcolor=$tbmaincolor><input type=password name=password2 size=25 value="$password2"></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>$extra_field_name.</font></td><td bgcolor=$tbmaincolor><input type=text name=extra size=25 value="$extra1"></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor>$terms<br><center><table border="0" cellpadding="0" cellspacing="0 width="280">
<tr><td width="280" bgcolor="Navy" height="1" colspan=2><img src="$imagesrc/space.gif" width=1 height=1></td></tr><tr><td width="260"><small><font face="Arial">I agree to the above terms and conditions --&gt;</font></small></td><td width="20"><input type="checkbox" name="agree" value="agree"></td></tr></table></center></font></td></tr>
<tr><td bgcolor=$tbmaincolor align=right><br><input type=reset value=Reset></td><td bgcolor=$tbmaincolor align=center><br><input type=submit value=Submit></td></tr>
</table></form>
~;
&footer;
	exit;
}
}

# This checks if email address is in correct format.
if ($emailok =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)/ || $emailok !~ /^.+\@(\[?)[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,4}|[0-9]{1,3})(\]?)$/) {
&header;
print qq~
<form action="locked.cgi" method="post"><input type="hidden" name="validationcode" value="$validationcode"><table width=400 cellpadding=2 cellspacing=0 border=0 bgcolor=$tbmaincolor>
<tr><td colspan=2 bgcolor=$tbheadercolor><font face=$fontheaderface size=$fontheadersize color=$fontheadercolor>$sitename: Account Signup Form Error</font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor>Sorry, but we found some problems with your submission.  Please make the following corrections:</font><br>
<font face=$fontface size=$fontsize color=#FF0000><ul><li>Your email address is in an incorrect format, please correct it and re-submit.<br></ul></font></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>Full Name</font></td><td bgcolor=$tbmaincolor><input type=text name=name size=25 value="$name"></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>Email Address.</font></td><td bgcolor=$tbmaincolor><input type=text name=email1 size=25 value="$email1"></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>Desired Username.</font></td><td bgcolor=$tbmaincolor><input type=text name=username size=25 value="$username"></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>Desired Password.</font></td><td bgcolor=$tbmaincolor><input type=password name=password size=25 value="$password"></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>Confirm Password.</font></td><td bgcolor=$tbmaincolor><input type=password name=password2 size=25 value="$password2"></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>$extra_field_name.</font></td><td bgcolor=$tbmaincolor><input type=text name=extra size=25 value="$extra1"></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor>$terms<br><center><table border="0" cellpadding="0" cellspacing="0 width="280">
<tr><td width="280" bgcolor="Navy" height="1" colspan=2><img src="$imagesrc/space.gif" width=1 height=1></td></tr><tr><td width="260"><small><font face="Arial">I agree to the above terms and conditions --&gt;</font></small></td><td width="20"><input type="checkbox" name="agree" value="agree"></td></tr></table></center></font></td></tr>
<tr><td bgcolor=$tbmaincolor align=right><br><input type=reset value=Reset></td><td bgcolor=$tbmaincolor align=center><br><input type=submit value=Submit></td></tr>
</table></form>
~;
&footer;
	exit;

}

# Removes vetical pipes and colons from fields if their are any.  This will ruin the database structure if they do get into the database.
$usernameok =~ s/\|//g;
$passwordok =~ s/\|//g;
$emailok =~ s/\|//g;
$name =~ s/\|//g;
$extra =~ s/\|//g; 

$usernameok =~ s/\://g;
$passwordok =~ s/\://g;

# Check is email address already has account.
open (DATABASEM, "$membersdb");
@wholebasem = <DATABASEM>;
close (DATABASEM);
foreach $olduserm (@wholebasem) {
	chomp ($olduserm);
	# db looks like username|password|email|etc...
	@userm = split(/\|/, $olduserm);
	# check for duplicate email address in members db
	if ($emailok eq $userm[1]) {
&header;
print qq~
<table width=400 cellpadding=2 cellspacing=0 border=0 bgcolor=$tbmaincolor>
<tr><td colspan=2 bgcolor=$tbheadercolor><font face=$fontheaderface size=$fontheadersize color=$fontheadercolor>$sitename: Account Signup Form Error</font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor>Sorry, but you already have an account with the username, <b>$userm[2]</b>.<br>
Please <a href="manage.cgi?lost">click here</a> if you\'ve lost your password.
</font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor align=center><font face=$fontface size=$fontnotesize color=$fontcolor><a href="locked.cgi?edit">Edit Account Information</a> : <a href="locked.cgi?find">Request New Password</a> : <a href="locked.cgi?delete">Cancel Membership</a></font></td></tr>
</table>
~;
&footer;
		exit;
	}
# Checks for duplicate username in members db
	if ($usernameok eq $userm[2]) {
&header;
print qq~
<form action="locked.cgi" method="post"><input type="hidden" name="validationcode" value="$validationcode"><table width=400 cellpadding=2 cellspacing=0 border=0 bgcolor=$tbmaincolor>
<tr><td colspan=2 bgcolor=$tbheadercolor><font face=$fontheaderface size=$fontheadersize color=$fontheadercolor>$sitename: Account Signup Form Error</font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor>Sorry, but we found some problems with your submission.  Please make the following corrections:</font><br>
<font face=$fontface size=$fontsize color=#FF0000>Sorry, but the username, <b>$usernameok</b> was taken. Please choose another one.<br>We apologise for the inconvenience.</font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor>$terms<br><center><table border="0" cellpadding="0" cellspacing="0 width="280">
<tr><td width="280" bgcolor="Navy" height="1" colspan=2><img src="$imagesrc/space.gif" width=1 height=1></td></tr><tr><td width="260"><small><font face="Arial">I agree to the above terms and conditions --&gt;</font></small></td><td width="20"><input type="checkbox" name="agree" value="agree"></td></tr></table></center></font></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>Full Name</font></td><td bgcolor=$tbmaincolor><input type=text name=name size=25></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>Email Address.</font></td><td bgcolor=$tbmaincolor><input type=text name=email1 size=25></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>Confirm Email Address.</font></td><td bgcolor=$tbmaincolor><input type=text name=email2 size=25></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>Desired Username.</font></td><td bgcolor=$tbmaincolor><input type=text name=username size=25></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>Desired Password.</font></td><td bgcolor=$tbmaincolor><input type=password name=password size=25></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>Confirm Password.</font></td><td bgcolor=$tbmaincolor><input type=password name=password2 size=25></td></tr>
<tr><td bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor><br>$extra_field_name.</font></td><td bgcolor=$tbmaincolor><input type=text name=extra size=25></td></tr>
<tr><td bgcolor=$tbmaincolor align=right><br><input type=reset value=Reset></td><td bgcolor=$tbmaincolor align=center><br><input type=submit value=Submit></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor align=center><font face=$fontface size=$fontnotesize color=$fontcolor><a href="locked.cgi?edit">Edit Account Information</a> : <a href="locked.cgi?find">Request New Password</a> : <a href="locked.cgi?delete">Cancel Membership</a></font></td></tr>
</table></form>
~;
&footer;
		exit;
	}
}

&get_date;

# Encrypts password, opens db, locks it, writes to it, closes it.  Adds user to members.db basically.
$db_password = crypt($passwordok, "La");
open (DATABASE, ">>$membersdb") || warn "Locked Area Error: Cannot open database file: $!";
flock (DATABASE, LOCK_EX) || warn "Locked Area Error: Cannot flock database.  $!";
print DATABASE "$name|$emailok|$usernameok|$db_password|$extra|$date\n";
close (DATABASE);

# Encrypts password, opens password file, locks it, writes to it, closes it.  Adds user to password file basically.
$lasalt = &salt;
$enc_password = crypt($passwordok, "$lasalt");
open (HTPASSWD, ">>$htpasswd") || warn "Locked Area Error: Cannot open htpasswd file: $!";
flock (HTPASSWD, LOCK_EX) || warn "Locked Area Error: Cannot flock htpasswd file.  $!";
print HTPASSWD "$usernameok:$enc_password\n";
close (HTPASSWD);

# Send welcome email.
require "mails.pl";

# Display registration complete page.
&header;
print qq~
<table width=400 cellpadding=2 cellspacing=0 border=0 bgcolor=$tbmaincolor>
<tr><td colspan=2 bgcolor=$tbheadercolor><font face=$fontheaderface size=$fontheadersize color=$fontheadercolor>$sitename: Account Signup Complete</font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor>Thank you for joining $sitename.<br>Your account has now been fully created and you may now login.  Your account information and log-in details have now been emailed to you.<p>
<b>You entered the following details:</b><br>Desired Username: $usernameok<br>Email Address: $emailok<br>Full Name: $name<br>$extra_field_name: $extra<p>You should receive your login details via email within a few minutes.<p></font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor align=center><font face=$fontface size=$fontnotesize color=$fontcolor><a href="locked.cgi?edit">Edit Account Information</a> : <a href="locked.cgi?find">Request New Password</a> : <a href="locked.cgi?delete">Cancel Membership</a></font></td></tr>
</table>
~;
&footer;
exit;
} else {
# Displays if registration form is closed.  $signup_status not set to Online.
&get_date;
&header;
print qq~
<table width=400 cellpadding=2 cellspacing=0 border=0 bgcolor=$tbmaincolor>
<tr><td colspan=2 bgcolor=$tbheadercolor><font face=$fontheaderface size=$fontheadersize color=$fontheadercolor>$sitename: Account Signup Form</font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=#FF0000>I\'m afraid we\'re currently not accepting any new signups, please come back later.<p>
<b>Locked Area Note</b><br>
This is appearing because you have set the signup status to offline.  To change this please login to the Locked Area Lite v3.2 administration panel, then select the Configuration section.  Now, scroll to the bottom and tick the signup statis tick box, then click Update.  Your registration form should now be accessible.</font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor align=center><font face=$fontface size=$fontnotesize color=$fontcolor><a href="locked.cgi?edit">Edit Account Information</a> : <a href="locked.cgi?find">Request New Password</a> : <a href="locked.cgi?delete">Cancel Membership</a></font></td></tr>
</table>
~;
&footer;
}

}


sub print_delete {
&header;
print qq~
<table width=400 cellpadding=2 cellspacing=0 border=0 bgcolor=$tbmaincolor>
<tr><td colspan=2 bgcolor=$tbheadercolor><font face=$fontheaderface size=$fontheadersize color=$fontheadercolor>$sitename: Delete Account</font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor>
To delete your $sitename account, please enter your username and password below.<br>
<b>This will permanently delete your account!</b><p>
<form action="locked.cgi" method="post">
<input type="hidden" name="go_delete" value="yes">
<table width=300 cellpadding=2 cellspacing=0 border=0>
<tr><td><font face=$fontface size=$fontsize color=$fontcolor>Username:</font></td><td><input type="text" name="username" size="25"></td></tr>
<tr><td><font face=$fontface size=$fontsize color=$fontcolor>Password:</font></td><td><input type="password" name="password" size="25"></td></tr>
<tr><td></td><td align=center><input type="submit" name="remove" value="Delete Account"></td></tr>
</table></form><p></font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor align=center><font face=$fontface size=$fontnotesize color=$fontcolor><a href="locked.cgi?edit">Edit Account Information</a> : <a href="locked.cgi?find">Request New Password</a> : <a href="locked.cgi?delete">Cancel Membership</a></font></td></tr>
</table>
~;
&footer;
exit;
}

sub go_delete {
$user = $query->param(\'username\');
$pass = $query->param(\'password\');
$db_password = crypt($pass, "La");

	open (DATA, "$membersdb");
	@indata = <DATA>;
	close (DATA);
	foreach $entries (@indata){
		($name, $email, $username, $password, $url, $date) = split(/\|/, $entries);
		if ($username eq $user) {
			$found = 1;
			if ($db_password eq $password) {
				$rightpass = 1;
			}
			last;
		}
	}
	unless ($rightpass) {
		unless ($found) {

&header;
print qq~
<table width=400 cellpadding=2 cellspacing=0 border=0 bgcolor=$tbmaincolor>
<tr><td colspan=2 bgcolor=$tbheadercolor><font face=$fontheaderface size=$fontheadersize color=$fontheadercolor>$sitename: Delete Account Error</font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor>
The username, <i>$user</i> was not found in the members database.<p>
<form action="locked.cgi" method="post"><input type="hidden" name="go_delete" value="yes">
<table width=300 cellpadding=2 cellspacing=0 border=0>
<tr><td><font face=$fontface size=$fontsize color=$fontcolor>Username:</font></td><td><input type="text" name="username" size="25" value="$user"></td></tr>
<tr><td><font face=$fontface size=$fontsize color=$fontcolor>Password:</font></td><td><input type="password" name="password" size="25" value="$pass"></td></tr>
<tr><td></td><td align=center><input type="submit" name="remove" value="Delete Account"></td></tr>
</table></form><p></font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor align=center><font face=$fontface size=$fontnotesize color=$fontcolor><a href="locked.cgi?edit">Edit Account Information</a> : <a href="locked.cgi?find">Request New Password</a> : <a href="locked.cgi?delete">Cancel Membership</a></font></td></tr>
</table>
~;
&footer;
exit;
		}
&header;
print qq~
<table width=400 cellpadding=2 cellspacing=0 border=0 bgcolor=$tbmaincolor>
<tr><td colspan=2 bgcolor=$tbheadercolor><font face=$fontheaderface size=$fontheadersize color=$fontheadercolor>$sitename: Delete Account Error</font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor>
You did not enter a password so the account <i>$user</i> could not be deleted.<p>
<form action="locked.cgi" method="post"><input type="hidden" name="go_delete" value="yes">
<table width=300 cellpadding=2 cellspacing=0 border=0>
<tr><td><font face=$fontface size=$fontsize color=$fontcolor>Username:</font></td><td><input type="text" name="username" size="25" value="$user"></td></tr>
<tr><td><font face=$fontface size=$fontsize color=$fontcolor>Password:</font></td><td><input type="password" name="password" size="25" value="$pass"></td></tr>
<tr><td></td><td align=center><input type="submit" name="remove" value="Delete Account"></td></tr>
</table></form><p></font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor align=center><font face=$fontface size=$fontnotesize color=$fontcolor><a href="locked.cgi?edit">Edit Account Information</a> : <a href="locked.cgi?find">Request New Password</a> : <a href="locked.cgi?delete">Cancel Membership</a></font></td></tr>
</table>
~;
&footer;
exit;
	}
	
	open (WRITEDATA, ">$membersdb") || warn "Locked Area Error: Cannot open database file: $!";
	flock (WRITEDATA, LOCK_EX) || warn "Locked Area Error: Cannot flock database.  $!";;
	foreach $memberline (@indata) {
		($name, $email, $username, $password, $extra, $date) = split(/\|/, $memberline);
		if ($username eq $user) {
	if ($removeemail eq \'1\') {
	open (MAIL2, "|$mailprog -t") || die "Locked Area Error: Cannot open sendmail: $!";
	print MAIL2 "To: $adminmail\n";
	print MAIL2 "From: $adminmail\n";
	print MAIL2 "Subject: Locked Area, Account Removed\n\n";
	    print MAIL2 "The user, $user has removed their account from your member\'s area.\n";
	    print MAIL2 "\n";
	    print MAIL2 "Their details were as follows:\n";
    	    print MAIL2 "       Username:     	    $username\n";
            print MAIL2 "       Password:     	    $password\n";
            print MAIL2 "       Name:         	    $name\n";
            print MAIL2 "       Email:        	    $email\n";
            print MAIL2 "       $extra_field_name:  $extra\n";	    
	    print MAIL2 "\n";
	    print MAIL2 "Powered by Locked Area Lite v3.2, a product of LockedArea.com.\n";
	    print MAIL2 "             http://www.lockedarea.com/\n";
	close(MAIL2);
	}
		} else {
			print WRITEDATA $memberline;
		}
	}
	close (WRITEDATA);
	open (READHT, "$htpasswd") || warn "Locked Area Error: Cannot open password file: $!";
	@htpw = <READHT>;
	close (READHT);
	open (WRITEHT, ">$htpasswd") || warn "Locked Area Error: Cannot open password file: $!";
	flock (WRITEHT, LOCK_EX)|| warn "Locked Area Error: Cannot flock password file.  $!";
	foreach $passline (@htpw) {
		($htuser, $htpass) = split(/\:/, $passline);
		if ($htuser eq $user) {
		} else {
			print WRITEHT $passline;
		}
	}
	close (WRITEHT);
	

&header;
print qq~
<table width=400 cellpadding=2 cellspacing=0 border=0 bgcolor=$tbmaincolor>
<tr><td colspan=2 bgcolor=$tbheadercolor><font face=$fontheaderface size=$fontheadersize color=$fontheadercolor>$sitename: Account Deleted</font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor>
Your account, <i>$user</i> has now been removed from the members database.  You will no longer be able to access the member\'s area.<p></font></td></tr>
</table>
~;
&footer;
exit;
}

sub print_edit {
&header;
print qq~
<table width=400 cellpadding=2 cellspacing=0 border=0 bgcolor=$tbmaincolor>
<tr><td colspan=2 bgcolor=$tbheadercolor><font face=$fontheaderface size=$fontheadersize color=$fontheadercolor>$sitename: Edit Account Details</font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor>
Please login to modify your account details.<p><form action="locked.cgi" method="post"><input type="hidden" name="go_edit" value="yes">
<table width=300 cellpadding=2 cellspacing=0 border=0>
<tr><td><font face=$fontface size=$fontsize color=$fontcolor>Username:</font></td><td><input type="text" name="username" size="25"></td></tr>
<tr><td><font face=$fontface size=$fontsize color=$fontcolor>Password:</font></td><td><input type="password" name="password" size="25"></td></tr>
<tr><td></td><td align=center><input type="submit" name="login" value="Login"></td></tr>
</table></form>
<p></font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor align=center><font face=$fontface size=$fontnotesize color=$fontcolor><a href="locked.cgi?edit">Edit Account Information</a> : <a href="locked.cgi?find">Request New Password</a> : <a href="locked.cgi?delete">Cancel Membership</a></font></td></tr>
</table>
~;
&footer;
exit;
}

sub go_edit {
	$username = $query->param(\'username\');
	$password = $query->param(\'password\');
	$db_password = crypt($password, "La");
	open (DATA, "$membersdb") || warn "Locked Area Error: Cannot open database file: $!";
	@indata = <DATA>;
	close (DATA);
	foreach $entries (@indata){
		($name, $email, $user, $pass, $extra, $date) = split(/\|/, $entries);
		if ($user eq $username) {
			$found = 1;
			if ($pass eq $db_password) {
				last;
			} else {
&header;
print qq~
<table width=400 cellpadding=2 cellspacing=0 border=0 bgcolor=$tbmaincolor>
<tr><td colspan=2 bgcolor=$tbheadercolor><font face=$fontheaderface size=$fontheadersize color=$fontheadercolor>$sitename: Edit Account Details Error</font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor>
The password you entered was incorrect.<p><form action="locked.cgi" method="post"><input type="hidden" name="go_edit" value="yes">
<table width=300 cellpadding=2 cellspacing=0 border=0>
<tr><td><font face=$fontface size=$fontsize color=$fontcolor>Username:</font></td><td><input type="text" name="username" size="25" value="$username"></td></tr>
<tr><td><font face=$fontface size=$fontsize color=$fontcolor>Password:</font></td><td><input type="password" name="password" size="25" value="$password"></td></tr>
<tr><td></td><td align=center><input type="submit" name="login" value="Login"></td></tr>
</table></form>
<p></font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor align=center><font face=$fontface size=$fontnotesize color=$fontcolor><a href="locked.cgi?edit">Edit Account Information</a> : <a href="locked.cgi?find">Request New Password</a> : <a href="locked.cgi?delete">Cancel Membership</a></font></td></tr>
</table>
~;
&footer;
exit;
			}
		}
	}
	unless ($found) {
&header;
print qq~
<table width=400 cellpadding=2 cellspacing=0 border=0 bgcolor=$tbmaincolor>
<tr><td colspan=2 bgcolor=$tbheadercolor><font face=$fontheaderface size=$fontheadersize color=$fontheadercolor>$sitename: Edit Account Details Error</font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor>
The username you entered was not found in the member\'s database.<p><form action="locked.cgi" method="post">
<input type="hidden" name="go_edit" value="yes">
<table width=300 cellpadding=2 cellspacing=0 border=0>
<tr><td><font face=$fontface size=$fontsize color=$fontcolor>Username:</font></td><td><input type="text" name="username" size="25" value="$username"></td></tr>
<tr><td><font face=$fontface size=$fontsize color=$fontcolor>Password:</font></td><td><input type="password" name="password" size="25" value="$password"></td></tr>
<tr><td></td><td align=center><input type="submit" name="login" value="Login"></td></tr>
</table></form>
<p></font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor align=center><font face=$fontface size=$fontnotesize color=$fontcolor><a href="locked.cgi?edit">Edit Account Information</a> : <a href="locked.cgi?find">Request New Password</a> : <a href="locked.cgi?delete">Cancel Membership</a></font></td></tr>
</table>
~;
&footer;
exit;
	}
&header;
print qq~
<table width=400 cellpadding=2 cellspacing=0 border=0 bgcolor=$tbmaincolor>
<tr><td colspan=2 bgcolor=$tbheadercolor><font face=$fontheaderface size=$fontheadersize color=$fontheadercolor>$sitename: Edit Account Details</font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor>
To update your account information, modify the information below.  You must enter your current password.  If you wish to change your password, please enter your current password and complete the new and confirm password fields.
<p><form action="locked.cgi" method="post">
<input type="hidden" name="go_acctedit" value="yes">
<input type="hidden" name="username" value="$username">
<input type="hidden" name="password" value="$password">
<table width=300 cellpadding=2 cellspacing=0 border=0>
<tr><td><font face=$fontface size=$fontsize color=$fontcolor>Username:</font></td><td><font face=$fontface size=$fontsize color=$fontcolor>$username</font></td></tr>
<tr><td><font face=$fontface size=$fontsize color=$fontcolor>New Password:</font></td><td><input type="password" name="newpassword" size="25"></td></tr>
<tr><td><font face=$fontface size=$fontsize color=$fontcolor>Confirm Password:</font></td><td><input type="password" name="newpassword2" size="25"></td></tr>
<tr><td><font face=$fontface size=$fontsize color=$fontcolor>Name:</font></td><td><input type="text" name="name" size="25" value="$name"></td></tr>
<tr><td><font face=$fontface size=$fontsize color=$fontcolor>Email:</font></td><td><input type="text" name="email" size="25" value="$email"></td></tr>
<tr><td><font face=$fontface size=$fontsize color=$fontcolor>$extra_field_name:</font></td><td><input type="text" name="extra" size="25" value="$extra"></td></tr>
<tr><td></td><td align=center><input type="submit" name="update_acct" value="Update Account"></td></tr>
</table></form>
<p></font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor align=center><font face=$fontface size=$fontnotesize color=$fontcolor><a href="locked.cgi?edit">Edit Account Information</a> : <a href="locked.cgi?find">Request New Password</a> : <a href="locked.cgi?delete">Cancel Membership</a></font></td></tr>
</table>
~;
&footer;
exit;
}

sub go_acctedit {
	$username = $query->param(\'username\');
	$password = $query->param(\'password\');
	if ($password eq "") {
	&header;
	print qq~
	<table width=400 cellpadding=2 cellspacing=0 border=0 bgcolor=$tbmaincolor>
	<tr><td colspan=2 bgcolor=$tbheadercolor><font face=$fontheaderface size=$fontheadersize color=$fontheadercolor>$sitename: Update Account Details Error</font></td></tr>
	<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor>
	Your account details have not been updated because you did not enter your current password.
	<p>
	</td></tr></table>
	~;	
	&footer;
	exit;
	}
	$newpassword = $query->param(\'newpassword\');
	$newpassword2 = $query->param(\'newpassword2\');	
	$name = $query->param(\'name\');
	$email = $query->param(\'email\');
	$extra = $query->param(\'extra\');

	
	# This checks if email address is in correct format.
	if ($email =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)/ || $email !~ /^.+\@(\[?)[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,4}|[0-9]{1,3})(\]?)$/) {
	$email = "";
	}
	
	unless ($username && $newpassword && $newpassword2 && $email && $name && $extra) {

	&header;
	print qq~
	<table width=400 cellpadding=2 cellspacing=0 border=0 bgcolor=$tbmaincolor>
	<tr><td colspan=2 bgcolor=$tbheadercolor><font face=$fontheaderface size=$fontheadersize color=$fontheadercolor>$sitename: Update Account Details Error</font></td></tr>
	<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor>Sorry, but we found some problems with your submission.  Please make the following corrections:</font><br>
	<font face=$fontface size=$fontsize color=#FF0000><ul>
	~;
		print "<li>Either you didn\'t enter a username or it was less than 6 characters in length.<br>" unless ($username);
		print "" unless ($usernameok && $emailok);
		print "<li>Either you didn\'t enter a new password or it was less than 6 characters in length.<br>" unless ($newpassword);
		print "" unless ($newpassword && $emailok);
		print "<li>Either you didn\'t comfirm your password or it was less than 6 characters in length.<br>" unless ($newpassword2);
		print "" unless ($newpassword && $newpassword2);
		print "<li>Either you didn\'t enter a email address or the email address you entered didn\'t match your confirm email address<br>" unless ($email);
		print "" unless ($emailok && $agree);
		print "<li>You did not enter your full name.<br>" unless ($name);
		print "" unless ($emailok && $agree);
		print "<li>You did not enter your $extra_field_name.<br>" unless ($extra);
		print qq~
	</ul></font>
	<p>
	<p><form action="locked.cgi" method="post">
	<input type="hidden" name="go_acctedit" value="yes">
	<input type="hidden" name="username" value="$username">
	<input type="hidden" name="password" value="$password">
	<table width=300 cellpadding=2 cellspacing=0 border=0>
	<tr><td><font face=$fontface size=$fontsize color=$fontcolor>Username:</font></td><td><font face=$fontface size=$fontsize color=$fontcolor>$username</font></td></tr>
	<tr><td><font face=$fontface size=$fontsize color=$fontcolor>New Password:</font></td><td><input type="password" name="newpassword" value="$newpassword" size="25"></td></tr>
	<tr><td><font face=$fontface size=$fontsize color=$fontcolor>Confirm Password:</font></td><td><input type="password" name="newpassword2" size="25" value="$newpassword"></td></tr>
	<tr><td><font face=$fontface size=$fontsize color=$fontcolor>Name:</font></td><td><input type="text" name="name" size="25" value="$name"></td></tr>
	<tr><td><font face=$fontface size=$fontsize color=$fontcolor>Email:</font></td><td><input type="text" name="email" size="25" value="$email"></td></tr>
	<tr><td><font face=$fontface size=$fontsize color=$fontcolor>$extra_field_name:</font></td><td><input type="text" name="extra" size="25" value="$extra"></td></tr>
	<tr><td></td><td align=center><input type="submit" name="update_acct" value="Update Account"></td></tr>
	</table></form>
	<p></font></td></tr>
	<tr><td colspan=2 bgcolor=$tbmaincolor align=center><font face=$fontface size=$fontnotesize color=$fontcolor><a href="locked.cgi?edit">Edit Account Information</a> : <a href="locked.cgi?find">Request New Password</a> : <a href="locked.cgi?delete">Cancel Membership</a></font></td></tr>
	</table>

	~;
	&footer;
		exit;
}
	

	$passwordcheck = "Yes";
	$passwordcheck = "No" if (length($newpassword) < "6");
	if (($newpassword eq "") && ($newpassword2 eq "")) {
	$passchange=2;
	$passwordcheck = "No";
	}
	$db_password = crypt($password, "La");
		open (DATA, "$membersdb") || warn "Locked Area Error: Cannot open database file: $!";
	@indata = <DATA>;
	close (DATA);
	open (WRITEDATA, ">$membersdb") || warn "Locked Area Error: Cannot open database file: $!";
	flock (WRITEDATA, LOCK_EX) || warn "Locked Area Error: Cannot flock database.  $!";
	foreach $entries (@indata){
		($oname, $oemail, $ousername, $opassword, $oextra, $date) = split(/\|/, $entries);
		if ($ousername eq $username) {
		   if ($db_password eq $opassword) {
			chomp ($date);
			if ($newpassword eq $newpassword2) {
				if ($passwordcheck eq "Yes") {
				
					$lasalt = &salt;
				$enc_password = crypt($newpassword, "$lasalt");
				$changepassword = crypt($newpassword, "La");
				print WRITEDATA "$name|$email|$username|$changepassword|$extra|$date\n";
					open (DATA1, "$htpasswd") || warn "Locked Area Error: Cannot open database file: $!";
					@indata1 = <DATA1>;
					close (DATA1);
						open (WRITEDATA1, ">$htpasswd") || warn "Locked Area Error: Cannot open htpasswd file: $!";
						flock (WRITEDATA1, LOCK_EX) || warn "Locked Area Error: Cannot flock htpasswd file.  $!";
						foreach $entries1 (@indata1){
						($huser, $hpass) = split(/\:/, $entries1);
						if ($username eq $huser) {
						chomp ($huser);
						print WRITEDATA1 "$ousername:$enc_password\n";
							} else {
						print WRITEDATA1 $entries1;
							}
						}
						close (WRITEDATA1);
				$passchange = 1;
				
			} else {
			if (($newpassword eq "") && ($newpassword2 eq "")) {
						$passchange = 2;
			}
			print WRITEDATA "$name|$email|$ousername|$opassword|$extra|$date\n";
			}
			} else {
			if (($newpassword eq "") && ($newpassword2 eq "")) {
						$passchange = 2;
			}
			print WRITEDATA "$name|$email|$ousername|$opassword|$extra|$date\n";
			}
			} else {
			print WRITEDATA $entries;
			}
		} else {
			print WRITEDATA $entries;
		}
	}	
	
	close (WRITEDATA);
&header;
print qq~
<table width=400 cellpadding=2 cellspacing=0 border=0 bgcolor=$tbmaincolor>
<tr><td colspan=2 bgcolor=$tbheadercolor><font face=$fontheaderface size=$fontheadersize color=$fontheadercolor>$sitename: Account Details Updated</font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor>
Your account details have now been updated.  They are now as follows:<p>
<table width=300 cellpadding=2 cellspacing=0 border=0>
<tr><td><font face=$fontface size=$fontsize color=$fontcolor>Username:</font></td><td><font face=$fontface size=$fontsize color=$fontcolor>$username</font></td></tr>
<tr><td><font face=$fontface size=$fontsize color=$fontcolor>Name:</font></td><td><font face=$fontface size=$fontsize color=$fontcolor>$name</font></td></tr>
<tr><td><font face=$fontface size=$fontsize color=$fontcolor>Email:</font></td><td><font face=$fontface size=$fontsize color=$fontcolor>$email</font></td></tr>
<tr><td><font face=$fontface size=$fontsize color=$fontcolor>$extra_field_name:</font></td><td><font face=$fontface size=$fontsize color=$fontcolor>$extra</font></td></tr>
</table>
<p>
~;
if ($passchange eq 1) {
print "Your password was changed as per your request.\n";
} elsif ($passchange eq 2) {
print "\n";
} else {
print "Their was a problem with your password change request so you\'re password was not changed, this may be because it was less than 5 character long or because the confirmation password did not match your new password.\n";
}
print qq~
</font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor align=center><font face=$fontface size=$fontnotesize color=$fontcolor><a href="locked.cgi?edit">Edit Account Information</a> : <a href="locked.cgi?find">Request New Password</a> : <a href="locked.cgi?delete">Cancel Membership</a></font></td></tr>
</table>
~;
&footer;
exit;
}


sub print_findpass {
&header;
print qq~
<table width=400 cellpadding=2 cellspacing=0 border=0 bgcolor=$tbmaincolor>
<tr><td colspan=2 bgcolor=$tbheadercolor><font face=$fontheaderface size=$fontheadersize color=$fontheadercolor>$sitename: Request New Password</font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor>To be sent a new password, please enter your email address below.<br>
<i>You must use the email address you registered your account with.</i><p><form action="locked.cgi" method="post">
<input type="hidden" name="go_pass" value="yes">
<table width=300 cellpadding=2 cellspacing=0 border=0>
<tr><td><font face=$fontface size=$fontsize color=$fontcolor>Email Address:</font></td><td><input type="text" name="email" size="25"></td></tr>
<tr><td></td><td align=center><input type="submit" name="send" value="Send Password"></td></tr>
</table></form>
<p></font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor align=center><font face=$fontface size=$fontnotesize color=$fontcolor><a href="locked.cgi?edit">Edit Account Information</a> : <a href="locked.cgi?find">Request New Password</a> : <a href="locked.cgi?delete">Cancel Membership</a></font></td></tr>
</table>
~;
&footer;
exit;
}

sub go_pass {
$email = $query->param(\'email\');
	open (DATA, "$membersdb") || warn "Locked Area Error: Cannot open database file: $!";
	@indata = <DATA>;
	close (DATA);
	open (WRITEDATA, ">$membersdb") || warn "Locked Area Error: Cannot open database file: $!";
	flock (WRITEDATA, LOCK_EX) || warn "Locked Area Error: Cannot flock database.  $!";
	foreach $entries (@indata){
		($oname, $oemail, $ousername, $opassword, $oextra, $odate) = split(/\|/, $entries);
		if ($oemail eq $email) {
		$email_found = 1;
		$genpassword = &salt(8);
		$lasalt = &salt(2);
		$enc_password = crypt($genpassword, "$lasalt");
		$db_password = crypt($genpassword, "La");
		   	chomp ($date);
			print WRITEDATA "$oname|$oemail|$ousername|$db_password|$oextra|$odate";
				open (DATA1, "$htpasswd") || warn "Locked Area Error: Cannot open htpasswd file: $!";
				@indata1 = <DATA1>;
				close (DATA1);
				open (WRITEDATA1, ">$htpasswd") || warn "Locked Area Error: Cannot open htpasswd file: $!";
				flock (WRITEDATA1, LOCK_EX) || warn "Locked Area Error: Cannot flock htpasswd file.  $!";
				foreach $entries1 (@indata1){
				($huser, $hpass) = split(/\:/, $entries1);
				if ($ousername eq $huser) {
				chomp ($huser);
				print WRITEDATA1 "$ousername:$enc_password\n";
				} else {
				print WRITEDATA1 $entries1;
				}
				}
				close (WRITEDATA1);
				open (MAIL2, "|$mailprog -t") || warn "Locked Area Error: Cannot open sendmail: $!";
				print MAIL2 "To: $oemail\n";
				print MAIL2 "From: $adminmail\n";
				print MAIL2 "Subject: $sitename: Your New Password\n\n";
				    print MAIL2 "\n";
				    print MAIL2 "Your new login details for $sitename as per your request are:\n";
				    print MAIL2 "\n";
				    print MAIL2 "Username: $ousername\n";
			    	    print MAIL2 "Password: $genpassword\n";
				    print MAIL2 "\n";
				    print MAIL2 "Best Regards,\n";
				    print MAIL2 "	$adminname\n";
				    print MAIL2 "\n";	    
				    print MAIL2 "Powered by Locked Area Lite v3.2, a product of LockedArea.com.\n";
				    print MAIL2 "             http://www.lockedarea.com/\n";
				close(MAIL2);
			} else {
			print WRITEDATA $entries;
		}
	
	}
	close (WRITEDATA);
if ($email_found eq 1) {
&header;
print qq~
<table width=400 cellpadding=2 cellspacing=0 border=0 bgcolor=$tbmaincolor>
<tr><td colspan=2 bgcolor=$tbheadercolor><font face=$fontheaderface size=$fontheadersize color=$fontheadercolor>$sitename: New Password Sent</font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor>A new password has been emailed to your email address, <i>$email</i>.
<p></font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor align=center><font face=$fontface size=$fontnotesize color=$fontcolor><a href="locked.cgi?edit">Edit Account Information</a> : <a href="locked.cgi?find">Request New Password</a> : <a href="locked.cgi?delete">Cancel Membership</a></font></td></tr>
</table>
~;
&footer;
exit;
} else {
&header;
print qq~
<table width=400 cellpadding=2 cellspacing=0 border=0 bgcolor=$tbmaincolor>
<tr><td colspan=2 bgcolor=$tbheadercolor><font face=$fontheaderface size=$fontheadersize color=$fontheadercolor>$sitename: Request Password Error</font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor><font face=$fontface size=$fontsize color=$fontcolor>The email address <i>$email</i> was not found in the database so a new password could not be sent.  Please feel free to try again.<br>
<i>You must use the email address you registered your account with.</i><p><form action="locked.cgi" method="post">
<input type="hidden" name="go_pass" value="yes">
<table width=300 cellpadding=2 cellspacing=0 border=0>
<tr><td><font face=$fontface size=$fontsize color=$fontcolor>Email Address:</font></td><td><input type="text" name="email" size="25" value="$email"></td></tr>
<tr><td></td><td align=center><input type="submit" name="send" value="Send Password"></td></tr>
</table></form>
<p></font></td></tr>
<tr><td colspan=2 bgcolor=$tbmaincolor align=center><font face=$fontface size=$fontnotesize color=$fontcolor><a href="locked.cgi?edit">Edit Account Information</a> : <a href="locked.cgi?find">Request New Password</a> : <a href="locked.cgi?delete">Cancel Membership</a></font></td></tr>
</table>
~;
&footer;
exit;
}
}

# Generates random salt.
sub salt {
   my ($maxlen) = $_[0] || 2;
   my (@vowel) = (qw (a a 2 e e e 3 i i i o o o u u 6 ai au ay ea
                      ee eu ia ie io oa oi oo oy));
   my (@consonant) = (qw (b c d f 2 h j k l m 6 p qu 8 s t v w x 9 th st
                          sh ph ng nd));
   my ($salt) = "";
   srand;                 
   my ($vowelnext) = int(rand(2));  # Initialise to 0 or 1 (ie true or false)
   do { if ($vowelnext) { $salt .= $vowel[rand(@vowel)]; } else { $salt .= $consonant[rand(@consonant)]; }
   $vowelnext = !$vowelnext; } 
   until length($salt) >= $maxlen;
   return $salt;
}

# Generates the date for database use specifically.
sub get_date {
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
	@months = ("01","02","03","04","05","06","07","08","09","10","11","12");
	@digits = split(//,$sec);
	$size = @digits;
	if ($size == 1) {
		$sec = "0$sec";
	}
	@digits = split(//,$min);
	$size = @digits;
	if ($size == 1) {
		$min = "0$min";
	}
	$year=$year+1900;
	@digits = split(//,$mday);
	$size = @digits;
	if ($size == 1) {
		$mday = "0$mday";
	}
	
	$date = "@months[$mon]/$mday/$year";
}


sub header {
# Please do not remove the below.  It causes not harm to you.
print "<!-- Generated by Locked Area Lite v3.2 Linux Stable -->";
open(HEADER,"header.inc");
while(<HEADER>) {
   print $_;
	}
}

sub footer {
# The below copyright notice may not be modified in anyway!  It is too remain at all times and be visible in all HTML generated by Locked Area Lite.
print qq~
<table width=400 cellpadding=2 cellspacing=0 border=0><tr><td align=right>
<font size="1" face="Arial">Powered by <a href="http://www.locked-area.com/html/">Locked Area Lite</a> v3.2 Linux Stable, a product of <a href="http://www.lockedarea.com/">LockedArea.com</a>.<br>
Copyright &copy; 1999 - 2003 Neil Skirrow and LockedArea.com, All Rights Reserved.</font></td></tr></table>
~;
# The above copyright notice may not be modified in anyway!  It is too remain at all times and be visible in all HTML generated by Locked Area Lite.
# Removing the copyright note, text and link back is a criminal offence and a breech of the contract you have with LockedArea.com.  Doing so will result in legal action!
open(FOOTER,"footer.inc");
while(<FOOTER>) {
   print $_;
	}
}';
close(LOCKED);

open(LOGGER, ">$cgiscriptdir/logger.cgi");
print LOGGER "$pathperl\n";
print LOGGER '#######################################################
# Locked Area Lite Version 3.2 Linux Stable
#                  http://www.lockedarea.com/
# Originally Released:     1st September 1999 (v1.0)
# Latest Release:          29th September 2003 (v3.2)
#######################################################
#
# COPYRIGHT NOTE:
# Locked Area Lite may be used and modified by anyone so
# long as they have a fully registered copy and this 
# copyright notice and the comments above remain intact.
# By using this code you agree to indemnify Neil Skirrow 
# and LockedArea.com from any liability that might arise
# from its use. Selling the code for this program without 
# prior written consent is expressly forbidden. In other
# words, please ask first before you try and make money
# off of our program. Obtain permission before 
# redistributing this software over the Internet or in 
# any other medium. In all cases copyright and header 
# must remain intact.  We cannot be held responsible 
# for any harm this may cause. 
#
#######################################################
use CGI qw(:standard); 	# Calls CGI.pm Library
$query = new CGI;
use Fcntl qw(:flock);  	# Calls File Locking Library
#######################################################
# The above three lines are essential to the script, if
# they are causing you an error, you don\'t have the
# required modules to use Locked Area Lite v3.2 Linux.
# Contact your web host and ask them to install them as
# they are essential modules.
#######################################################
# To run the logging script paste the below code in
# the main page of your members area:
# <!--#exec cgi="/cgi-bin/logger.cgi"-->
# To view stats load the loggerstats.cgi file in your
# web broswer.
#######################################################
$date = localtime(time);
$user = $ENV{REMOTE_USER};
$ip = $ENV{\'REMOTE_ADDR\'};
$ref = $ENV{\'HTTP_REFERER\'};
$browser = $ENV{\'HTTP_USER_AGENT\'};
print "Content-type: text/html\n\n";
&run if ($ENV{\'REQUEST_METHOD\'} eq "GET");
sub run {
open (LOG, ">>userlog.txt") || warn "Locked Area Error: Cannot open log file: $!";
flock (LOG, LOCK_EX) || warn "Locked Area Error: Cannot flock log file.  $!";
print LOG "$user|$ip|$ref|$browser|$date|\n";
close (LOG);
   print "<font face=$fontface size=$fontsize color=$fontcolor>Welcome <b>$user</b></font>";
}';
close(LOGGER);

open(LOGIN, ">$cgiscriptdir/login.cgi");
print LOGIN "$pathperl\n";
print LOGIN '#######################################################
# Locked Area Lite Version 3.2 Linux Stable
#                  http://www.lockedarea.com/
# Originally Released:     1st September 1999 (v1.0)
# Latest Release:          29th September 2003 (v3.2)
#######################################################
#
# COPYRIGHT NOTE:
# Locked Area Lite may be used and modified by anyone so
# long as they have a fully registered copy and this 
# copyright notice and the comments above remain intact.
# By using this code you agree to indemnify Neil Skirrow 
# and LockedArea.com from any liability that might arise
# from its use. Selling the code for this program without 
# prior written consent is expressly forbidden. In other
# words, please ask first before you try and make money
# off of our program. Obtain permission before 
# redistributing this software over the Internet or in 
# any other medium. In all cases copyright and header 
# must remain intact.  We cannot be held responsible 
# for any harm this may cause. 
#
#######################################################
use CGI qw(:standard); 	# Calls CGI.pm Library
$query = new CGI;
use Fcntl qw(:flock);  	# Calls File Locking Library
#######################################################
# The above three lines are essential to the script, if
# they are causing you an error, you don\'t have the
# required modules to use Locked Area Lite v3.2 Linux.
# Contact your web host and ask them to install them as
# they are essential modules.
#######################################################
# THIS FILE REQUIRES NO MANUAL MODIFICATION TO BE USED
# WITH THE EXCEPTION OF THE PATH TO PERL ON THE TOP 
# LINE OTHERWISE ALL CONFIGURATION IS DONE FROM THE 
# ADMIN PANEL.
#######################################################
require "variables.pl";
$login = $query->param(\'login\');
&login if ($login && $ENV{\'REQUEST_METHOD\'} eq "POST");

&login_main;

sub dienice {
    ($errmsg) = @_;
    print "<h2>Error</h2>\n";
    print "$errmsg<p>\n";
    print "</body></html>\n";
    exit;
}

sub login_main {
print "Content-type: text/html\n\n";
	print qq~
<html>
<head>
<title>Please Login</title>
</head>
<body bgcolor="#FFFFFF" text="#000000" topmargin="0" leftmargin="0">
<div align="center"><center>
<table border="0" cellpadding="0" cellspacing="0" width="100%" height="100%">
  <tr>
    <td width="100%"><form action="login.cgi" method="POST">
      <input type="hidden" name="login" value="yes"><div align="center"><center><table
      border="0" cellpadding="0" cellspacing="0" width="303">
        <tr>
          <td width="303">
          <font face="Arial"><small>Username: <input type="text" name="username" size="20"></small><br>
          <font face="Arial"><small>Password: <input type="password" name="password" size="20"></small><br>
<input type="submit" value="Log In">
          </small></font></td>
        </tr>
      </table>
      </center></div>
    </form>
    </td>
  </tr>
</table>
</center></div>
</body>
</html>

~;
    exit;
}

sub login{
$username = $query->param(\'username\');
$password = $query->param(\'password\');

if ($login_style eq "1") {
    read(STDIN, $buffer, $ENV{\'CONTENT_LENGTH\'});
    print "Location:http://$username:$password\@$membersurl\n\n";
    exit;
} else {
    print "Content-type: text/html\n\n";
    print "<HTML><META HTTP-EQUIV=Refresh CONTENT=\'0;URL=http://$username:$password\@$membersurl\'></HTML>\n";
    exit;
    }
}';
close(LOGIN);

open(DETAILS, ">$cgiscriptdir/userdetails.cgi");
print DETAILS "$pathperl\n";
print DETAILS '#######################################################
# Locked Area Lite Version 3.2 Linux Stable
#                  http://www.lockedarea.com/
# Originally Released:     1st September 1999 (v1.0)
# Latest Release:          29th September 2003 (v3.2)
#######################################################
#
# COPYRIGHT NOTE:
# Locked Area Lite may be used and modified by anyone so
# long as they have a fully registered copy and this 
# copyright notice and the comments above remain intact.
# By using this code you agree to indemnify Neil Skirrow 
# and LockedArea.com from any liability that might arise
# from its use. Selling the code for this program without 
# prior written consent is expressly forbidden. In other
# words, please ask first before you try and make money
# off of our program. Obtain permission before 
# redistributing this software over the Internet or in 
# any other medium. In all cases copyright and header 
# must remain intact.  We cannot be held responsible 
# for any harm this may cause. 
#
#######################################################
use CGI qw(:standard); 	# Calls CGI.pm Library
$query = new CGI;
#######################################################
# The above two lines are essential to the script, if
# they are causing you an error, you don\'t have the
# required modules to use Locked Area Lite v3.2 Linux.
# Contact your web host and ask them to install them as
# they are essential modules.
#######################################################
# To run the logging script paste the below code in
# the main page of your members area:
# <!--#exec cgi="/cgi-bin/logger.cgi"-->
# To view stats load the loggerstats.cgi file in your
# web broswer.
#######################################################
require "variables.pl";
$date = localtime(time);
$user = $ENV{REMOTE_USER};
$ip = $ENV{\'REMOTE_ADDR\'};
$ref = $ENV{\'HTTP_REFERER\'};
$browser = $ENV{\'HTTP_USER_AGENT\'};
print "Content-type: text/html\n\n";
&run if ($ENV{\'REQUEST_METHOD\'} eq "GET");
sub run {
print qq~
<center>
<table border="0" cellpadding="0" cellspacing="0" width="440">
  <tr>
    <td width="440" colspan="2" color="$tbheadercolor"><font face=$fontface size=$fontsize color=$fontcolor>The following details about you
    have been logged for our records:</font></td>
  </tr>
  <tr>
    <td width="90" color="$tbmaincolor"><font face=$fontface size=$fontsize color=$fontcolor>Username:</font></td>
    <td width="350" color="$tbmaincolor"><font face=$fontface size=$fontsize color=$fontcolor>$user</font></td>
  </tr>
  <tr>
    <td width="90" color="$tbmaincolor"><font face=$fontface size=$fontsize color=$fontcolor>IP Address:</font></td>
    <td width="350" color="$tbmaincolor"><font face=$fontface size=$fontsize color=$fontcolor>$ip</font></td>
  </tr>
  <tr>
    <td width="90" color="$tbmaincolor"><font face=$fontface size=$fontsize color=$fontcolor>Web Browser:</font></td>
    <td width="350" color="$tbmaincolor"><font face=$fontface size=$fontsize color=$fontcolor>$browser</font></td>
  </tr>
  <tr>
    <td width="90" color="$tbmaincolor"><font face=$fontface size=$fontsize color=$fontcolor>Referrer:</font></td>
    <td width="350" color="$tbmaincolor"><font face=$fontface size=$fontsize color=$fontcolor>$ref</font></td>
  </tr>
  <tr>
    <td width="90" color="$tbmaincolor"><font face=$fontface size=$fontsize color=$fontcolor>Time:</font></td>
    <td width="350" color="$tbmaincolor"><font face=$fontface size=$fontsize color=$fontcolor>$date</font></td>
  </tr>
  <tr>
    <td width="440" colspan="2" color="$tbmaincolor"><font face=$fontface size=$fontnotesize color=$fontcolor>We do this so that we may catch
    leachers and remoev their accounts.&nbsp; It should not affect you in anyway providing
    you\'re using your membership honestly.</font></td>
  </tr>
</table>
</center>
~;
}';
close(DETAILS);

open(MAIL, ">$cgiscriptdir/mails.pl");
print MAIL '#######################################################
# Locked Area Lite Version 3.2 Linux Stable
#                  http://www.lockedarea.com/
# Originally Released:     1st September 1999 (v1.0)
# Latest Release:          29th September 2003 (v3.2)
#######################################################
#
# COPYRIGHT NOTE:
# Locked Area Lite may be used and modified by anyone so
# long as they have a fully registered copy and this 
# copyright notice and the comments above remain intact.
# By using this code you agree to indemnify Neil Skirrow 
# and LockedArea.com from any liability that might arise
# from its use. Selling the code for this program without 
# prior written consent is expressly forbidden. In other
# words, please ask first before you try and make money
# off of our program. Obtain permission before 
# redistributing this software over the Internet or in 
# any other medium. In all cases copyright and header 
# must remain intact.  We cannot be held responsible 
# for any harm this may cause. 
#
#######################################################

open (MAIL, "|$mailprog -t") || die "Locked Area Error: Cannot open sendmail: $!";
print MAIL "To: $emailok\n";
print MAIL "From: $adminmail\n";
print MAIL "Subject: $sitename: Thank You For Joining\n\n";
    print MAIL "Hello,\n";
    print MAIL "   Thank you for joining $sitename:\n";
    print MAIL2 "\n";
    print MAIL "   Your details are as follows:\n";
    print MAIL "       Username:     	   $usernameok\n";
    print MAIL "       Password:     	   $passwordok\n";
    print MAIL "       Name:         	   $name\n";
    print MAIL "       Email:        	   $emailok\n";
    print MAIL "       $extra_field_name:  $extra\n";
    print MAIL "           \n";
    print MAIL "    You may login here:\n";
    print MAIL "   http://$membersurl\n";
    print MAIL "\n";
    print MAIL "    Best Regards\n";
    print MAIL "        $adminname\n";
    print MAIL "\n";
    print MAIL "Powered by Locked Area Lite v3.2, a product of LockedArea.com.\n";
    print MAIL "             http://www.lockedarea.com/\n";
close(MAIL);

if ($newmemberemail eq \'1\') {
open (MAIL2, "|$mailprog -t") || die "Locked Area Error: Cannot open sendmail: $!";
print MAIL2 "To: $adminmail\n";
print MAIL2 "From: $adminmail\n";
print MAIL2 "Subject: New Member\n\n";
    print MAIL2 "Hello,\n";
    print MAIL2 "   You have a new member.\n";
    print MAIL2 "\n";
    print MAIL2 "   Here are their details:\n";
    print MAIL2 "       Username:     	    $usernameok\n";
    print MAIL2 "       Password:     	    $passwordok\n";
    print MAIL2 "       Name:         	    $name\n";
    print MAIL2 "       Email:        	    $emailok\n";
    print MAIL2 "       $extra_field_name:  $extra\n";
    print MAIL2 "           \n";
    print MAIL2 "\n";
    print MAIL2 "    Best Regards\n";
    print MAIL2 "        $adminname\n";
    print MAIL2 "\n";
    print MAIL2 "Powered by Locked Area Lite v3.2, a product of LockedArea.com.\n";
    print MAIL2 "             http://www.lockedarea.com/\n";
close(MAIL2);
}

1;';
close(MAIL);

open(HEADER, ">$cgiscriptdir/header.inc");
print HEADER '<!-- header.inc file, modify in control panel -->';
close(HEADER);

open(FOOTER, ">$cgiscriptdir/footer.inc");
print FOOTER '<!-- footer.inc file, modify in control panel -->';
close(FOOTER);

$var = `chmod $permission $cgiscriptdir/admin.cgi`;
$var = `chmod $permission $cgiscriptdir/locked.cgi`;
$var = `chmod $permission $cgiscriptdir/login.cgi`;
$var = `chmod $permission $cgiscriptdir/logger.cgi`;
$var = `chmod $permission $cgiscriptdir/userdetails.cgi`;
$var = `chmod $permission $cgiscriptdir/mails.pl`;
}

sub create_config {
$adminpassword1 = crypt($adminpassword, "La");
open (CON, ">>$cgiscriptdir/variables.pl") || &die_clean("Locked Area Error: Cannot open/create variables.pl file: $!\n");
flock (CON, LOCK_EX) || &die_clean("Locked Area Error: Cannot flock variables.pl.  $!\n");
print CON "# Variables.pl File.  Use the admin panel configuration section to modify the file, do not attempt to manually.\n";
print CON "\$sitename = \"$membersname\";\n";
print CON "\$membersdb = \"$membersdb\";\n";
print CON "\$htpasswd = \"$htpasswd\";\n";
print CON "\$htaccess = \"$membersdir/.htaccess\";\n";
print CON "\$extra_field_name = \"URL\";\n";
print CON "\$extra_url = \"1\";\n";
print CON "\$extra_required = \"1\";\n";
print CON "\$mailprog = \"$sendmail\";\n";
print CON "\$newmemberemail = \"1\";\n";
print CON "\$removeemail = \"1\";\n";
print CON "\$adminname = \"$adminname\";\n";
print CON "\$adminmail = \'$adminemail\';\n";;
print CON "\$adminpassword = \"$adminpassword1\";\n";
print CON "\$imageurl = \"$imageurl\";\n";
print CON "\$cgiurl = \"$cgiurl\";\n";
print CON "\$membersurl = \"$membersurl\";\n";
print CON "\$tbheadercolor = \"#DDDDDD\";\n";
print CON "\$tbmaincolor = \"#FFFFFF\";\n";
print CON "\$fontface = \"Arial\";\n";
print CON "\$fontcolor = \"#000000\";\n";
print CON "\$fontsize = \"2\";\n";
print CON "\$fontnotesize = \"1\";\n";
print CON "\$fontheaderface = \"Arial\";\n";
print CON "\$fontheadersize = \"2\";\n";
print CON "\$fontheadercolor = \"#000000\";\n";
print CON "\$terms = qq~\nTerms and Conditions\n~;\n";
print CON "\$show_records = \"25\";\n";
print CON "\$signup_status = \"Offline\";\n";
print CON "\$login_style = \"1\";\n";
print CON "1;\n";
close (CON);
$var = `chmod 666 $cgiscriptdir/variables.pl`;

}

sub create_members {


open(MEMBERSAREA, ">$membersdir/.htaccess") || &die_clean("Locked Area Error: Cannot open/create .htaccess file: $!\n");
flock (MEMBERSAREA, LOCK_EX) || &die_clean("Locked Area Error: Cannot flock .htaccess file.  $!\n");
print MEMBERSAREA "AuthType Basic\n";
print MEMBERSAREA "AuthName \"$membersname\"\n";
print MEMBERSAREA "AuthUserFile $htpasswd\n";
if ($cobaltraq ne "") { 
print MEMBERSAREA "AuthPAM_Enabled off\n"; 
}
print MEMBERSAREA "require valid-user\n";
close (MEMBERSAREA);


open(HTPASSWD, ">$htpasswd");
print HTPASSWD "";
close(HTPASSWD);

open(MEMDB, ">$membersdb") || &die_clean("Locked Area Error: Cannot open/create members database: $!\n");
flock (MEMDB, LOCK_EX) || &die_clean("Locked Area Error: Cannot flock members database: $!\n");
print MEMDB "";
close(MEMDB);

open(LOG, ">$cgiscriptdir/userlog.txt");
print LOG "";
close(LOG);

&get_date; 
open(INLOG, ">$cgiscriptdir/laliteinstall.txt");
print INLOG "Locked Area Lite v3.2 Linux Stable, installed on $date.\n";
print INLOG "\n";
print INLOG "Contents of variables.pl file at installation:\n";
print INLOG "\$sitename = \"$membersname\";\n";
print INLOG "\$membersdb = \"$membersdb\";\n";
print INLOG "\$htpasswd = \"$htpasswd\";\n";
print INLOG "\$htaccess = \"$membersdir/.htaccess\";\n";
print INLOG "\$mailprog = \"$sendmail\";\n";
print INLOG "\$adminname = \"$adminname\";\n";
print INLOG "\$adminmail = \'$adminemail\';\n";;
print INLOG "\$imageurl = \"$imageurl\";\n";
print INLOG "\$cgiurl = \"$cgiurl\";\n";
print INLOG "\$membersurl = \"$membersurl\";\n";
print INLOG "\n";
print INLOG "CGI Script Dir: $cgiscriptdir\n";
print INLOG "Member's Dir: $membersdir\n";
print INLOG "Member's DB: $membersdb\n";
print INLOG ".htpasswd File: $htpasswd\n";
print INLOG "Cobalt RAQ Server: $cobaltraq\n";
print INLOG "\n";
print INLOG "Copyright 2003 Neil Skirrow and LockedArea.com.  All Rights Reserved.\n";
close(INLOG);

$var = `chmod 666 $membersdir/.htaccess`;
$var = `chmod 666 $htpasswd`;
$var = `chmod 666 $membersdb`;
$var = `chmod 666 $cgiscriptdir/userlog.txt`;

# Create member's area welcome message.
if (-e "$membersdir/index.html") {
$members_create_index = 0;
} else {
open(MEMBERS, ">$membersdir/index.html") || &die_clean("Locked Area Error: Cannot open/create members index.html page: $!\n");
flock (MEMBERS, LOCK_EX) || &die_clean("Locked Area Error: Cannot flock members index.html page: $!\n");
print MEMBERS '<html><head><title>Locked Area Lite: Welcome</title>
</head><body bgcolor="#ffffff" text="#000000" link="#080000">

<div align="center">
  <center>
  <table border="0" cellspacing="0" width="500">
    <tr>
      <td bgcolor="#808080"><b><font color="#FFFFFF" size="2" face="Arial">Locked
        Area Lite: My Member\'s Area</font></b></td>
    </tr>
    <tr>
      <td bgcolor="#C0C0C0"><font face="Arial" size="2">Welcome to your first
        member\'s area created by Locked Area Lite v3.2 Linux Stable.</font>
        <p><b><font face="Arial" size="2">Please feel free to remove this file
        and put whatever you like in this directory.</font></b></p>
        <p><font size="2" face="Arial"><b>.htaccess<br>
        </b>This member\'s area is protected by .htaccess.&nbsp; .htaccess is an
        authentication system developed by Apache.&nbsp; It\'s pretty much the
        most secure main-stream authentication method available on Unix web
        servers.&nbsp; Infact, it\'s so secure it is pretty much impossible to
        \'hack\' through.&nbsp; Obviously, as with all security systems access is
        freely given to users with a valid username and password.</font></p>
        <p><font size="2" face="Arial"><b>Locked Area Lite<br>
        </b>As you are aware, Locked Area Lite is a freely distributed piece of
        internet software that is distributed by <a href="http://www.lockedarea.com/">LockedArea.com</a>.&nbsp;
        Please maintain all link backs in the cgi scripts and help spread the
        word about Locked Area.&nbsp; The more people who know about and use
        Locked Area, the better it will become as support builds.</font></p>
        <p><font size="2" face="Arial"><b>Member\'s Area Utilities<br>
        </b>There are a couple of utilities that come with Locked Area Lite for
        your member\'s area.&nbsp; These are logger.cgi and userdetails.cgi.</font></p>
        <p><font face="Arial" size="2">logger.cgi is a simple little script that
        will display a Welcome [username] message when loaded into the member\'s
        area using SSI tags.&nbsp; It also records details about the visitor to
        a log file.&nbsp; This log file can be read in the administration panel.<br>
        To call logger.cgi into your member\'s area html please place the
        following tag anywhere in your member\'s area html.</font></p>
        <p align="center"><i><b><font face="Arial" size="2">&lt;!--#exec
        cgi=&quot;/cgi-bin/logger.cgi&quot;--&gt;</font></b></i></p>
      </center>
      <p align="left"><font face="Arial" size="2">userdetails.cgi is also very
      simple but quite a nice little utility to use.&nbsp; It will simply
      display some information about the visitor in your html content.&nbsp; To
      call userdetails.cgi into your member\'s area html&nbsp; please place the
      following tag anywhere in your member\'s area html.</font></p>
      <p align="center"><i><b><font face="Arial" size="2">&lt;!--#exec
      cgi=&quot;/cgi-bin/userdetails.cgi&quot;--&gt;</font></b></i></p>
      <p align="left"><font face="Arial" size="2">If you didn\'t install the
      scripts into your cgi-bin, just modify the path.&nbsp; You must use a
      relative url.&nbsp; e.g. /dir/dir/logger.cgi or /cgi-bin/logger.cgi, not a
      full path or url.&nbsp; You may find that you need to use the extension .shtml
      to use SSI tags in your html.&nbsp; If you\'re not sure, contact your
      system administrator or have a look at your web host\'s FAQ page, most good
      hosts have them.</font></p>
      <p align="left"><font size="2" face="Arial"><b>Final Note<br>
      </b>Thank you very much for choosing Locked Area Lite.&nbsp; We hope you
      like it!&nbsp; Of course, all comments, complaints and suggestions are
      very welcome.&nbsp; Please email them to <a href="mailto:comments@lockedarea.com">comments@lockedarea.com</a>.<br>
      Please note, we are sadly not able to offer email support to Locked Area
      Lite users because the demands are way too high for our team to
      handle.&nbsp; If you do have any problems, please feel free to post them
      in the support forum or help desk.&nbsp; You should receive a quick
      response.</font></p>
      <p align="left"><font face="Arial" size="2">If you did like Locked Area
      Lite, please give us a rating.</font></p>
<center>	<table width=400 cellpadding=0 cellspacing=0 border=0><tr><td align=center width=200>
	
	<table border="0" cellpadding="0"
	            cellspacing="0" width=95%>
	              <tr><td align=center><b><font face="Arial" size="2">HotScripts.com</font></b></tr>
	              <tr>
	                <td><form action="http://www.hotscripts.com/cgi-bin/rate.cgi" method="POST">
	                  <input type="hidden" name="ID" value="4006"><b><div align="center"><p><font face="Arial"
	                  size="2">Script Rating:<br>
                        &nbsp; </font> </b>
                        <font face="Arial"
	                  size="2">
	                  <select name="ex_rate" size="1">
	<option value="5" selected>Excellent!</option>
	<option value="4">Very Good</option>
	<option value="3">Good</option>
	<option value="2">Fair</option>
	<option value="1">Poor</option>
	</select> <input type="submit" value="Rate It!"><br>&nbsp; </font></p>
                      </div>
	                </form>
	                </td>
	              </tr>
	            </table>
	
	
	</td><td align=center width=200>
	
	<table border="0" cellpadding="0"
	            cellspacing="0" width=95%>
	              <tr><td align=center><b><font face="Arial" size="2">The CGI Resource Index</font></b></tr>
	              <tr>
	                <td><form method="POST" action="http://cgi-resources.com/rate/index.cgi">
	                  <input type="hidden" name="referer" value="http://cgi-resources.com/"><input type="hidden"
	                  name="link_code" value="04463"><input type="hidden" name="category_name"
	                  value="Programs and Scripts/Perl/Password Protection/"><input type="hidden"
	                  name="link_name" value="Locked Area"><b><div align="center"><p><font size="2" face="Arial">Script Rating:&nbsp;<br>
                        </font> </b><font size="2" face="Arial"><select name="rating" size="1">
	                    <option selected>-- </option>
	                    <option>10 </option>
	                    <option>9 </option>
	                    <option>8 </option>
	                    <option>7 </option>
	                    <option>6 </option>
	                    <option>5 </option>
	                    <option>4 </option>
	                    <option>3 </option>
	                    <option>2 </option>
	                    <option>1 </option>
	                  </select> <input type="submit" value="Rate It!"><br>
                        10 - Great / 0 - Poor</font></p>
                      </div>
	                </form>
	                </td>
	              </tr>
	            </table>
	
</td></tr></table></center><p><b><font size="2" face="Arial">Contact Information<br>
      </font></b><font size="2" face="Arial"><a href="http://www.lockedarea.com/">http://www.lockedarea.com/<br>
      </a>Comments, Complaints, Suggestions: <a href="mailto:comments@lockedarea.com">comments@lockedarea.com<br>
      </a>Sales Questions: <a href="mailto:sales@lockedarea.com">sales@lockedarea.com<br>
      </a>Support, Bug Reports, Problems etc: <a href="http://www.locked-area.com/html/members/">http://www.locked-area.com/html/members/</a></font><p><font size="2" face="Arial"><b>Useful
      Resources:<br>
      </b><a href="http://www.lockedarea.com/">LockedArea.com</a>, <a href="http://www.cgidevelopers.com/">CGIDevelopers.com</a></font><p><font size="2" face="Arial">&copy; Copyright
      1999 - 2003 Neil Skirrow and LockedArea.com.&nbsp; All Rights Reserved.</font></td>
  </tr>
  </table>
</div>

</body>

</html>';
close(MEMBERS);
}
}

sub get_date {
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
	@months = ("01","02","03","04","05","06","07","08","09","10","11","12");
	@digits = split(//,$sec);
	$size = @digits;
	if ($size == 1) {
		$sec = "0$sec";
	}
	@digits = split(//,$min);
	$size = @digits;
	if ($size == 1) {
		$min = "0$min";
	}
	$year=$year+1900;
	@digits = split(//,$mday);
	$size = @digits;
	if ($size == 1) {
		$mday = "0$mday";
	}
	$date = "@months[$mon]/$mday/$year";
}

sub die_clean {
    ($errmsg) = @_;
    print qq~
    <html><head><title>Locked Area Pro Installation Wizard</title></head>
    <body bgcolor="#F1F1F1" text="Navy" link="#000000" vlink="#111111">
    <table width=500 cellpadding=2 cellspacing=0 border=0>
    <tr><td bgcolor="#dddddd"><b><font face=Arial size=2>Locked Area Lite Installation Wizard -
        Installation Error</font></b></td></tr>
    <tr><td><font face=Arial size=2>
    <br>
    </font>
    <ul>
    <font face="Arial" size="2">The following error occured during installation:</font>
    </ul>
        <font face=Arial size=2>
    <p>$errmsg
    </font><br>  
    If you have any problems, please don't hesitate to visit the <a href="http://www.locked-area.com/html/members/">LockedArea.com member's area</a> for assistance.
    <p><font face=Arial size=2>
    &nbsp;
    </font></td></tr>
    <tr><td bgcolor="#dddddd"><font face="Arial" size="1">&copy; Copyright 1999 -
        2003 Neil Skirrow and <a href="http://www.locked-area.com">LockedArea.com</a>.  All Rights Reserved.</font></td></tr>
    </table>
    </body></html>
    ~;
exit;
}

# That's the installation file.  Please don't modify it.
# Copyright 2003 Neil Skirrow and LockedArea.com.  All Rights Reserved.
# Usage of this script is strictly restricted to the domain/url/ip address you have registered with us.